VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2505
   ClientLeft      =   1245
   ClientTop       =   1530
   ClientWidth     =   4740
   Height          =   2910
   Left            =   1185
   LinkTopic       =   "Form1"
   ScaleHeight     =   2505
   ScaleWidth      =   4740
   Top             =   1185
   Width           =   4860
   Begin VB.CommandButton cmdStop 
      Caption         =   "Stop"
      Height          =   615
      Left            =   2640
      TabIndex        =   5
      Top             =   1800
      Width           =   1935
   End
   Begin VB.CommandButton cmdSign 
      Caption         =   "               Sign                         (PingPong                  Non-Continuous)"
      Height          =   615
      Left            =   2640
      TabIndex        =   4
      Top             =   1020
      Width           =   1935
   End
   Begin VB.CommandButton cmdJack 
      Caption         =   "      Jack-in-the-Box                 (PingPong)"
      Height          =   615
      Left            =   2640
      TabIndex        =   3
      Top             =   240
      Width           =   1935
   End
   Begin VB.CommandButton cmdSafe 
      Caption         =   "            Safe Open                       (Reversible)"
      Height          =   615
      Left            =   180
      TabIndex        =   2
      Top             =   1800
      Width           =   1935
   End
   Begin VB.CommandButton cmdRainbow 
      Caption         =   "             Rainbow                (Cycle Non-Continuous)"
      Height          =   615
      Left            =   180
      TabIndex        =   1
      Top             =   1020
      Width           =   1935
   End
   Begin VB.CommandButton cmdClock 
      Caption         =   "                Clock                              (Cycle)"
      Height          =   615
      Left            =   180
      TabIndex        =   0
      Top             =   240
      Width           =   1935
   End
   Begin GreenTreeInTray.GTInTray GTInTray1 
      Left            =   2190
      Top             =   270
      _ExtentX        =   714
      _ExtentY        =   741
      PropA           =   1
      AnimationStyle  =   0
      Continuous      =   -1  'True
      Enabled         =   -1  'True
      Interval        =   0
      ReverseAnimation=   0   'False
      ToolTipText     =   ""
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdClock_Click()
    Dim iLoop As Integer
    
    GTInTray1.Icons.Clear
    For iLoop = 1 To 48
        GTInTray1.Icons.Add , , LoadPicture(App.Path & "\..\icons\clock" & Right$("0" & CStr(iLoop), 2) & ".ico")
    Next iLoop
    GTInTray1.Interval = 150
    GTInTray1.ToolTipText = "InTray Clock Sample"
    GTInTray1.AnimationStyle = gtCycle
    GTInTray1.Continuous = True
    GTInTray1.Animate = True
    EnableAllButtons False
End Sub

Private Sub cmdJack_Click()
    Dim iLoop As Integer
    
    GTInTray1.Icons.Clear
    GTInTray1.Icons.Add , , LoadPicture(App.Path & "\..\icons\Jack1.ico")
    For iLoop = 1 To 6
        GTInTray1.Icons.Add , , LoadPicture(App.Path & "\..\icons\Jack" & CStr(iLoop) & ".ico")
    Next iLoop
    GTInTray1.Icons.Add , , LoadPicture(App.Path & "\..\icons\Jack6.ico")
    GTInTray1.Icons.Add , , LoadPicture(App.Path & "\..\icons\Jack6.ico")
    GTInTray1.Interval = 150
    GTInTray1.ToolTipText = "InTray Sign Sample"
    GTInTray1.AnimationStyle = gtPingPong
    GTInTray1.Continuous = True
    EnableAllButtons False
    GTInTray1.Animate = True
End Sub

Private Sub cmdRainbow_Click()
    Dim iLoop As Integer
    
    GTInTray1.Icons.Clear
    For iLoop = 1 To 4
        GTInTray1.Icons.Add , , LoadPicture(App.Path & "\..\icons\rainbow" & CStr(iLoop) & ".ico")
    Next iLoop
    GTInTray1.Interval = 200
    GTInTray1.ToolTipText = "InTray Rainbow Sample"
    GTInTray1.AnimationStyle = gtCycle
    GTInTray1.Continuous = False
    GTInTray1.Animate = True
    EnableAllButtons False
End Sub

Private Sub cmdSign_Click()
    Dim iLoop As Integer
    
    GTInTray1.Icons.Clear
    For iLoop = 1 To 6
        GTInTray1.Icons.Add , , LoadPicture(App.Path & "\..\icons\Sign" & CStr(iLoop) & ".ico")
    Next iLoop
    GTInTray1.Interval = 150
    GTInTray1.ToolTipText = "InTray Sign Sample"
    GTInTray1.AnimationStyle = gtPingPong
    GTInTray1.Continuous = False
    GTInTray1.Animate = True
    EnableAllButtons False
End Sub

Private Sub cmdSafe_Click()
    Dim iLoop As Integer
    
    If GTInTray1.Icons.Count = 0 Then
        For iLoop = 1 To 14
            GTInTray1.Icons.Add , , LoadPicture(App.Path & "\..\icons\Safe" & Right$("0" & CStr(iLoop), 2) & ".ico")
        Next iLoop
        GTInTray1.Interval = 200
        GTInTray1.ToolTipText = "InTray Safe Sample"
        GTInTray1.AnimationStyle = gtCycle
        GTInTray1.Continuous = False
        GTInTray1.Animate = True
        cmdClock.Enabled = False
        cmdJack.Enabled = False
        cmdRainbow.Enabled = False
        cmdSign.Enabled = False
        cmdStop.Enabled = True
    End If
    Select Case cmdSafe.Caption
        Case "            Safe Open                       (Reversible)"
            GTInTray1.ReverseAnimation = False
            cmdSafe.Caption = "            Safe Close                       (Reversible)"
        Case "            Safe Close                       (Reversible)"
            GTInTray1.ReverseAnimation = True
            cmdSafe.Caption = "            Safe Open                       (Reversible)"
    End Select
    GTInTray1.Animate = True
End Sub
Private Sub cmdStop_Click()
    GTInTray1.ReverseAnimation = False
    GTInTray1.Interval = 0
    GTInTray1.Animate = False
    GTInTray1.Icons.Clear
    EnableAllButtons True
End Sub

Private Sub EnableAllButtons(ByVal Enabled As Boolean)
    cmdClock.Enabled = Enabled
    cmdJack.Enabled = Enabled
    cmdRainbow.Enabled = Enabled
    cmdSign.Enabled = Enabled
    cmdSafe.Enabled = Enabled
    cmdStop.Enabled = Not Enabled
End Sub


