Attribute VB_Name = "MGlobals"
Option Explicit

'Windows Error messages
Public Const errInvalidPropertyValue = 380

'GT Error Messages

'Windows Api message IDs
Public Const WM_ACTIVATE = &H6
Public Const WM_SYSCOLORCHANGE = &H15

'ExtTextOut Types
Public Const ETO_OPAQUE = 2

'DrawFrameControl Constants
Public Const DFC_BUTTON = 4
Public Const DFCS_BUTTONCHECK = &H0
Public Const DFCS_INACTIVE = &H100
Public Const DFCS_PUSHED = &H200
Public Const DFCS_CHECKED = &H400
Public Const DFCS_FLAT = &H4000

'   ***** system color constants
Public Const COLOR_WINDOW = 5

Public Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Public Declare Function DrawFrameControl Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal un1 As Long, ByVal un2 As Long) As Long
Public Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Public Declare Function ExtTextOut Lib "gdi32" Alias "ExtTextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal wOptions As Long, lpRect As RECT, ByVal lpString As String, ByVal nCount As Long, lpDx As Long) As Long
Public Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Public Declare Function DrawEdge Lib "user32" (ByVal hdc As Long, _
        qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long) As Long
Public Declare Function DrawFocusRect Lib "user32" (ByVal hdc As Long, _
        lpRect As RECT) As Long
Public Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, _
        ByVal x As Long, ByVal y As Long) As Long
Public Declare Function ExcludeClipRect Lib "gdi32" (ByVal hdc As Long, _
        ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Public Declare Function SelectClipRgn Lib "gdi32" (ByVal hdc As Long, _
        ByVal hRgn As Long) As Long
Public Declare Function GetBkColor Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function SetBkColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Public Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Public Declare Function GetTextColor Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function GetActiveWindow Lib "user32" () As Long ' ver 1.0a



