VERSION 5.00
Begin VB.UserControl GTListbox 
   Appearance      =   0  'Flat
   BackColor       =   &H80000005&
   ClientHeight    =   1410
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1395
   PropertyPages   =   "GTListbox.ctx":0000
   ScaleHeight     =   94
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   93
   ToolboxBitmap   =   "GTListbox.ctx":0058
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   30
      Left            =   150
      Top             =   330
   End
   Begin VB.ListBox lstSort 
      Height          =   255
      Left            =   -1.5e5
      Sorted          =   -1  'True
      TabIndex        =   0
      Top             =   240
      Width           =   645
   End
   Begin VB.HScrollBar scrLR 
      Height          =   255
      LargeChange     =   20
      Left            =   60
      SmallChange     =   5
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   1080
      Visible         =   0   'False
      Width           =   915
   End
   Begin VB.VScrollBar scrUD 
      Height          =   975
      Left            =   1140
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   0
      Visible         =   0   'False
      Width           =   255
   End
End
Attribute VB_Name = "GTListbox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
'   ******************************************************************************
'   * Purpose:  This is the listbox control.
'   * File:         GTListbox.ctl
'   ******************************************************************************
Option Explicit
'   ***** selectiontype constants
Public Enum GTSelectionTypeConstants
    GTListbox
    gtListView
End Enum
'   *****
'   ***** sort order constants
Public Enum GTSortOrderConstants
    gtAscending
    gtDescending
End Enum
'   *****
'   ***** Appearance constants
Public Enum GTAppearanceConstants
    gtFlat
    gt3D
End Enum
'   *****
'   ***** Borderstyle constants
Public Enum GTBorderStyleConstands
    gtNone
    gtFixedSingle
End Enum
'   *****
'   ***** OLEdrop constants
Public Enum GTOLEDropConstants
    gtOLEDropNone
    gtOLEDropManual
End Enum
'   *****
'   ***** paint area constants
Private Const Columns = 1
Private Const Rows = 2
Private Const Both = Columns Or Rows
'   *****

'   ***** default property values
Private Const m_def_ShowColumnHeaders = True
Private Const m_def_SortKey = 0
'   *****

'   ***** variables
Private m_CSplitter As CSplitter
Private m_CDrawRect As CDrawRect
Private m_iOffset As Integer
Private m_oLastSelected As GTListItem
Private m_lResizeCol As Long
Private m_oActiveColumnHeader As GTColumnHeader
Private m_iScalePerPixel As Integer
Private m_bMouseDown As Boolean
Private m_bSkip As Boolean
Private m_lColumnHeaderHeight As Long
Private m_lListItemHeight As Long
Private m_bHasFocus As Boolean
Private m_CPaint As CPaint
'   *****

'   ***** property variables
Private WithEvents m_oListItems As GTListItems
Attribute m_oListItems.VB_VarHelpID = -1
Private WithEvents m_oColumnHeaders As GTColumnHeaders
Attribute m_oColumnHeaders.VB_VarHelpID = -1
Private m_oSelectedItem As GTListItem
Private m_bRedraw As Boolean
Private m_eSelType As GTSelectionTypeConstants
Private m_bMultiSelect As Boolean
Private m_iSortKey As Integer
Private m_eSortOrder As GTSortOrderConstants
Private m_bSorted As Boolean
Private m_oColumnHeaderFont As Font
Private m_oListItemFont As Font
Private m_lColumnHeaderForeColor As OLE_COLOR
Private m_lListItemForeColor As OLE_COLOR
Private m_picMouseIcon As Picture
Private m_eMousePointer As MousePointerConstants
Private m_eBorderStyle As GTBorderStyleConstands
Private m_eAppearance As GTAppearanceConstants
Private m_bShowColumnHeaders As Boolean
Private m_eOLEDragMode As OLEDragConstants
Private m_bParentIsActive As Boolean ' ver 1.0a Used with timer
'   *****

'   ***** Event Declarations:
Event ColumnClick(ColumnHeader As GTColumnHeader)
Attribute ColumnClick.VB_Description = "Occurs when a ColumnHeader object in a ListView control is clicked."
Attribute ColumnClick.VB_HelpID = 114
Event ListItemClick(ListItem As GTListItem)
Attribute ListItemClick.VB_Description = "Occurs when a ListItem object is clicked or selected"
Attribute ListItemClick.VB_HelpID = 128
Event Click()
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Attribute Click.VB_HelpID = 129
Attribute Click.VB_UserMemId = -600
Event DblClick()
Attribute DblClick.VB_Description = "Occurs when you press and release a mouse button and then press and release it again over an object."
Attribute DblClick.VB_HelpID = 106
Attribute DblClick.VB_UserMemId = -601
Event KeyDown(KeyCode As Integer, Shift As Integer)
Attribute KeyDown.VB_Description = "Occurs when the user presses a key while an object has the focus."
Attribute KeyDown.VB_HelpID = 32
Attribute KeyDown.VB_UserMemId = -602
Event KeyUp(KeyCode As Integer, Shift As Integer)
Attribute KeyUp.VB_Description = "Occurs when the user releases a key while an object has the focus."
Attribute KeyUp.VB_HelpID = 32
Attribute KeyUp.VB_UserMemId = -604
Event KeyPress(KeyAscii As Integer)
Attribute KeyPress.VB_Description = "Occurs when the user presses and releases an ANSI key."
Attribute KeyPress.VB_HelpID = 36
Attribute KeyPress.VB_UserMemId = -603
Event MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Attribute MouseDown.VB_HelpID = 124
Attribute MouseDown.VB_UserMemId = -605
Event MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Attribute MouseMove.VB_HelpID = 121
Attribute MouseMove.VB_UserMemId = -606
Event MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."
Attribute MouseUp.VB_HelpID = 124
Attribute MouseUp.VB_UserMemId = -607
Event OLECompleteDrag(Effect As Long) '
Attribute OLECompleteDrag.VB_Description = "OLECompleteDrag event"
Attribute OLECompleteDrag.VB_HelpID = 120
Event OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single)
Attribute OLEDragDrop.VB_Description = "OLEDragDrop event"
Attribute OLEDragDrop.VB_HelpID = 119
Event OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single, State As Integer)
Attribute OLEDragOver.VB_Description = "OLEDragOver event"
Attribute OLEDragOver.VB_HelpID = 118
Event OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
Attribute OLEGiveFeedback.VB_Description = "OLEGiveFeedback event"
Attribute OLEGiveFeedback.VB_HelpID = 116
Event OLESetData(Data As DataObject, DataFormat As Integer)
Attribute OLESetData.VB_Description = "OLESetData event"
Attribute OLESetData.VB_HelpID = 117
Event OLEStartDrag(Data As DataObject, AllowedEffects As Long)
Attribute OLEStartDrag.VB_Description = "OLEStartDrag event"
Attribute OLEStartDrag.VB_HelpID = 115
'   *****

'   ***** Returns/sets the oledragmode constant
Public Property Let OLEDragMode(eMode As OLEDragConstants)
Attribute OLEDragMode.VB_Description = " Returns/Sets whether this control can act as an OLE drag/drop source, and whether this process is started automatically or under programmatic control."
Attribute OLEDragMode.VB_HelpID = 62
Attribute OLEDragMode.VB_ProcData.VB_Invoke_PropertyPut = ";Misc"
    m_eOLEDragMode = eMode
    PropertyChanged "OLEDragMode"
End Property
Public Property Get OLEDragMode() As OLEDragConstants
    OLEDragMode = m_eOLEDragMode
End Property

'   *****
Private Sub Timer1_Timer()
'   ***** Ver 1.0a Now using a timer instead of subclassing the parent
    Dim bParentIsActive As Boolean
    
    bParentIsActive = IsParentActiveWindow() ' check to see if the parent is the actve window
    
    If m_bParentIsActive = bParentIsActive Then
        ' do nothing
    Else
        SetActiveFlag
        Paint Rows, bParentIsActive
    End If
'   *****
End Sub

'   ***** OLE Drag/Drop events
Private Sub UserControl_OLECompleteDrag(Effect As Long)
    RaiseEvent OLECompleteDrag(Effect)
End Sub
Public Sub OLEDrag()
Attribute OLEDrag.VB_Description = "Starts an OLE drag/drop event with the given control as the source."
Attribute OLEDrag.VB_HelpID = 135
    UserControl.OLEDrag
End Sub
Private Sub UserControl_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single)
    RaiseEvent OLEDragDrop(Data, Effect, Button, Shift, x, y)
End Sub
Private Sub UserControl_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single, State As Integer)
    RaiseEvent OLEDragOver(Data, Effect, Button, Shift, x, y, State)
End Sub
Private Sub UserControl_OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
    RaiseEvent OLEGiveFeedback(Effect, DefaultCursors)
End Sub
Private Sub UserControl_OLESetData(Data As DataObject, DataFormat As Integer)
    RaiseEvent OLESetData(Data, DataFormat)
End Sub
Private Sub UserControl_OLEStartDrag(Data As DataObject, AllowedEffects As Long)
    RaiseEvent OLEStartDrag(Data, AllowedEffects)
End Sub

'   ***** Returns the hWnd of the usercontrol.
Public Property Get hWnd() As Long
Attribute hWnd.VB_Description = "Returns a handle to a form or control."
Attribute hWnd.VB_HelpID = 43
Attribute hWnd.VB_UserMemId = -515
    hWnd = UserControl.hWnd
End Property
'   *****

'   ***** Returns/sets whether the columnheaders will be visible
Public Property Let ShowColumnHeaders(bShow As Boolean)
Attribute ShowColumnHeaders.VB_Description = "Returns/sets whether or not a ListView control's column headers are hidden."
Attribute ShowColumnHeaders.VB_HelpID = 73
Attribute ShowColumnHeaders.VB_ProcData.VB_Invoke_PropertyPut = ";Appearance"
    m_bShowColumnHeaders = bShow
    m_lColumnHeaderHeight = GetColumnHeaderHeight()
    PropertyChanged "ShowColumnHeaders"
End Property
Public Property Get ShowColumnHeaders() As Boolean
    ShowColumnHeaders = m_bShowColumnHeaders
End Property
'   *****

'   ***** Returns/sets whether the listitems will be sorted. Used with the
'   ***** sortkey and sortorder properties.
Public Property Let Sorted(bSorted As Boolean)
Attribute Sorted.VB_Description = "Indicates whether the elements of a control are automatically sorted alphabetically."
Attribute Sorted.VB_HelpID = 77
Attribute Sorted.VB_ProcData.VB_Invoke_PropertyPut = ";Misc"
    m_bSorted = bSorted
    
    If Ambient.UserMode Then ' only at runtime
        If m_bSorted And m_iSortKey > 0 Then
            SortByColumn
            Paint Rows
        End If
    End If
    
    PropertyChanged "Sorted"
End Property
Public Property Get Sorted() As Boolean
    Sorted = m_bSorted
End Property
'   *****

'   ***** Returns/sets the enabled property
Public Property Let Enabled(bEnabled As Boolean)
    UserControl.Enabled = bEnabled
    PropertyChanged "Enabled"
End Property
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
Attribute Enabled.VB_HelpID = 18
Attribute Enabled.VB_ProcData.VB_Invoke_Property = "General;Behavior"
Attribute Enabled.VB_UserMemId = -514
    Enabled = UserControl.Enabled
End Property
'   *****

'   ***** Returns/sets the value of OLEDropMode
Public Property Let OLEDropMode(eDropMode As GTOLEDropConstants)
Attribute OLEDropMode.VB_Description = "Returns/Sets whether this control can act as an OLE drop target."
Attribute OLEDropMode.VB_HelpID = 62
Attribute OLEDropMode.VB_ProcData.VB_Invoke_PropertyPut = ";Misc"
    UserControl.OLEDropMode = eDropMode
    PropertyChanged "OLEDropMode"
End Property
Public Property Get OLEDropMode() As GTOLEDropConstants
    OLEDropMode = UserControl.OLEDropMode
End Property
'   *****

'   ***** Returns/sets whether the control will have a border or not
Public Property Let BorderStyle(eStyle As GTBorderStyleConstands)
    m_eBorderStyle = eStyle
    PropertyChanged "BorderStyle"
    
    CalcOffset
    
    Paint Both
End Property
Public Property Get BorderStyle() As GTBorderStyleConstands
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
Attribute BorderStyle.VB_HelpID = 2
Attribute BorderStyle.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BorderStyle.VB_UserMemId = -504
    BorderStyle = m_eBorderStyle
End Property
'   *****

'   ***** Returns/sets whether the control will appear 3D or Flat.
Public Property Let Appearance(eAppearance As GTAppearanceConstants)
    m_eAppearance = eAppearance
    PropertyChanged "Appearance"
    
    CalcOffset
    
    Paint Both
End Property
Public Property Get Appearance() As GTAppearanceConstants
Attribute Appearance.VB_Description = "Returns/sets whether or not controls, Forms or an MDIForm are painted at run time with 3-D effects."
Attribute Appearance.VB_HelpID = 22
Attribute Appearance.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute Appearance.VB_UserMemId = -520
Attribute Appearance.VB_MemberFlags = "200"
    Appearance = m_eAppearance
End Property
'   *****

'   ***** Returns/sets the font used by the columnheaders
Public Property Set ColumnHeaderFont(oFont As StdFont)
Attribute ColumnHeaderFont.VB_Description = "Returns the Font object for the ColumnHeaders."
Attribute ColumnHeaderFont.VB_HelpID = 16
Attribute ColumnHeaderFont.VB_ProcData.VB_Invoke_PropertyPutRef = ";Font"
    Set m_oColumnHeaderFont = oFont
    
    m_lColumnHeaderHeight = GetColumnHeaderHeight()
'   ***** Pass the columnheaders height to the columnheaders and
'   ***** listitems collections
    m_oColumnHeaders.ColumnHeaderHeight = m_lColumnHeaderHeight
    m_oListItems.ColumnHeaderHeight = m_lColumnHeaderHeight
'   *****
    Paint Both
    
    PropertyChanged "ColumnHeaderFont"
End Property
Public Property Get ColumnHeaderFont() As StdFont
    Set ColumnHeaderFont = m_oColumnHeaderFont
End Property
'   *****

'   ***** Returns/sets the font used by the listitems
Public Property Set Font(oFont As StdFont)
    Set m_oListItemFont = oFont
    Set UserControl.Font = oFont
    
    m_lListItemHeight = GetListItemHeight()
    m_oListItems.TextHeight = m_lListItemHeight ' pass to the listitems collection
    Paint Rows
    
    PropertyChanged "Font"
End Property
Public Property Get Font() As StdFont
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_HelpID = 31
Attribute Font.VB_ProcData.VB_Invoke_Property = ";Font"
Attribute Font.VB_UserMemId = -512
    Set Font = m_oListItemFont
End Property
'   *****

'   ***** Returns/sets the MousePointer constant.
Public Property Let MousePointer(eMouse As MousePointerConstants)
Attribute MousePointer.VB_Description = "Returns/sets the type of mouse pointer displayed when over part of an object."
Attribute MousePointer.VB_HelpID = 59
    m_eMousePointer = eMouse
    UserControl.MousePointer = eMouse
    PropertyChanged "MousePointer"
End Property
Public Property Get MousePointer() As MousePointerConstants
    MousePointer = m_eMousePointer
End Property
'   *****

'   ***** Returns/sets the MouseIcon property
Public Property Set MouseIcon(picIcon As StdPicture)
Attribute MouseIcon.VB_Description = "Sets a custom mouse icon."
Attribute MouseIcon.VB_HelpID = 58
    Set m_picMouseIcon = picIcon
    Set UserControl.MouseIcon = picIcon
    PropertyChanged "MouseIcon"
End Property
Public Property Get MouseIcon() As StdPicture
    Set MouseIcon = m_picMouseIcon
End Property
'   *****

'   ***** Returns/sets the column to sort by
Public Property Let SortKey(iSortKey As Integer)
Attribute SortKey.VB_Description = "Returns/sets the current sort key."
Attribute SortKey.VB_HelpID = 78
Attribute SortKey.VB_ProcData.VB_Invoke_PropertyPut = ";Misc"
'   ***** Make sure the sort key is valid
    If iSortKey < 0 Or iSortKey > m_oColumnHeaders.Count Then
        MsgBox "SortKey value must be between 0 and the number of ColumnHeaders.", vbInformation
        Exit Property
    End If
'   *****

    m_iSortKey = iSortKey
    If Ambient.UserMode Then ' only at runtime
        If m_bSorted And m_iSortKey > 0 Then
            SortByColumn
            Paint Rows
        End If
    End If
    PropertyChanged "SortKey"
End Property
Public Property Get SortKey() As Integer
    SortKey = m_iSortKey
End Property
'   *****

'   ***** Returns/sets the order the column in SortKey will be sorted.
Public Property Let SortOrder(eSortOrder As GTSortOrderConstants)
Attribute SortOrder.VB_Description = " Returns/sets whether or not the ListItems will be sorted in ascending or descending order."
Attribute SortOrder.VB_HelpID = 79
Attribute SortOrder.VB_ProcData.VB_Invoke_PropertyPut = ";Misc"
    m_eSortOrder = eSortOrder
    If Ambient.UserMode Then ' only at runtime
        If m_bSorted Then
            SortByColumn
            Paint Rows
        End If
    End If
    PropertyChanged "SortOrder"
End Property
Public Property Get SortOrder() As GTSortOrderConstants
    SortOrder = m_eSortOrder
End Property
Public Property Set SelectedItem(oListItem As GTListItem)
Attribute SelectedItem.VB_Description = "Returns a reference to the currently selected ListItem object."
Attribute SelectedItem.VB_HelpID = 71
    Set m_oSelectedItem = oListItem
    m_oListItems.ResetSelected ' unselect the other listitems
    
'   ***** set the property on the listitem in the collection
    m_oListItems(oListItem.Index).Selected = True
'   *****

    Paint Rows
End Property
'   *****

'   ***** Returns the current listitem.
Public Property Get SelectedItem() As GTListItem
    Set SelectedItem = m_oSelectedItem
End Property
'   *****

'   ***** Returns/sets whether multiple listitems can be selected at a time.
Public Property Let MultiSelect(bSelect As Boolean)
Attribute MultiSelect.VB_Description = "Returns/sets a value indicating whether a user can make multiple selections in the GTListbox control and how the multiple selections can be made."
Attribute MultiSelect.VB_HelpID = 60
Attribute MultiSelect.VB_ProcData.VB_Invoke_PropertyPut = ";Behavior"
    m_bMultiSelect = bSelect
    PropertyChanged "MultiSelect"
    Paint Rows
End Property
Public Property Get MultiSelect() As Boolean
    MultiSelect = m_bMultiSelect
End Property
'   *****

'   ***** Returns/sets the value of SelectionType. Allows Listbox or ListView selection
Public Property Let SelectionType(eSelType As GTSelectionTypeConstants)
Attribute SelectionType.VB_Description = "Returns/sets the whether SelectionType."
Attribute SelectionType.VB_HelpID = 72
Attribute SelectionType.VB_ProcData.VB_Invoke_PropertyPut = ";Behavior"
    m_eSelType = eSelType
    Paint Rows
    PropertyChanged "SelectionType"
End Property
Public Property Get SelectionType() As GTSelectionTypeConstants
    SelectionType = m_eSelType
End Property
'   *****

'   ***** Returns/sets the value of redraw. When false the control won't redraw.
'   ***** This will speed up loading listitems
Public Property Let Redraw(bRedraw As Boolean)
    m_bRedraw = bRedraw
        
    If m_oListItems.Count > 0 Then
'   ***** When set to true, automatically redraws
        If m_bRedraw Then
            MakeScrollbarsVisible
            SetHScrollbarMax
            If m_bSorted And m_iSortKey > 0 Then
                SortByColumn
            End If
        End If
'   *****
    End If
    
    Paint Both
End Property
Public Property Get Redraw() As Boolean
Attribute Redraw.VB_Description = "Returns/sets whether the control will draw."
Attribute Redraw.VB_HelpID = 66
Attribute Redraw.VB_MemberFlags = "400"
    Redraw = m_bRedraw
End Property
'   *****

'   ***** Returns/sets the BackColor property for the listitems
Public Property Let BackColor(lBackColor As OLE_COLOR)
    UserControl.BackColor = lBackColor
    PropertyChanged "BackColor"
    Paint Rows
End Property
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
Attribute BackColor.VB_HelpID = 5000
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BackColor.VB_UserMemId = -501
    BackColor = UserControl.BackColor
End Property
'   *****

'   ***** Returns/sets the forecolor property for the listitems
Public Property Let ForeColor(lForeColor As OLE_COLOR)
    m_lListItemForeColor = lForeColor
    PropertyChanged "ForeColor"
    Paint Rows
End Property
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
Attribute ForeColor.VB_HelpID = 5000
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute ForeColor.VB_UserMemId = -513
    ForeColor = m_lListItemForeColor
End Property
'   *****

'   ***** Returns/sets the forecolor property for the columnheaders
Public Property Let ColumnHeaderForeColor(lForeColor As OLE_COLOR)
Attribute ColumnHeaderForeColor.VB_Description = "sReturns/sets the background color used to display text and graphics in an object."
Attribute ColumnHeaderForeColor.VB_HelpID = 25
Attribute ColumnHeaderForeColor.VB_ProcData.VB_Invoke_PropertyPut = ";Appearance"
    m_lColumnHeaderForeColor = lForeColor
    Paint Columns
    PropertyChanged "ColumnHeaderForeColor"
End Property
Public Property Get ColumnHeaderForeColor() As OLE_COLOR
    ColumnHeaderForeColor = m_lColumnHeaderForeColor
End Property
'   *****

'   ***** Returns a reference to the ColumnHeaders collection
Public Property Get ColumnHeaders() As GTColumnHeaders
Attribute ColumnHeaders.VB_Description = "Returns a reference to a collection of ColumnHeader objects."
Attribute ColumnHeaders.VB_HelpID = 26
    Set ColumnHeaders = m_oColumnHeaders
End Property
'   *****

'   ***** Returns a reference to the ListItems collection
Public Property Get ListItems() As GTListItems
Attribute ListItems.VB_Description = "Returns a reference to a collection of ListItem objects."
Attribute ListItems.VB_HelpID = 53
    Set ListItems = m_oListItems
End Property
'   *****

'   ***** Ver 1.0a No longer used
'Private Sub GTMsgHook1_Message(ByVal hWnd As Long, ByVal MsgID As Long, ByVal wParam As Long, ByVal lParam As Long)
''   ****************************************************************************
''   * Params:   hWnd: the window handle that is subclassed, MsgID: the message that was intercepted, wParam: the wParam of the
''   *               message, lParam: the lParam of the message
''   * Purpose:  Fires when a Message in the Messages collection for the Window is intercepted
''   ****************************************************************************
'    Select Case MsgID
'        Case WM_ACTIVATE:
''   ***** Ver 1.0a
'            Paint Rows, (wParam = 2)
''            m_bHasFocus = (wParam = 2) And m_bHasFocus ' 2 means the form has focus
''            Paint Rows
''   *****
'        Case WM_SYSCOLORCHANGE:
'            Paint Both
'    End Select
'
'End Sub
'   *****
Private Sub lstSort_GotFocus()
'   ****************************************************************************
'   * Purpose:  Fires when the listbox get focus. This will fire the gotfocus
'   *               event for the usercontrol. There is a bug in the scrollbars
'   *               that allow the scrollbars to get focus even when the tabstop
'   *               property is set to false. This gets around that.
'   ****************************************************************************
    UserControl_GotFocus
End Sub

Private Sub lstSort_KeyDown(KeyCode As Integer, Shift As Integer)
    UserControl_KeyDown KeyCode, Shift
End Sub

Private Sub lstSort_KeyPress(KeyAscii As Integer)
    UserControl_KeyPress KeyAscii
End Sub

Private Sub lstSort_KeyUp(KeyCode As Integer, Shift As Integer)
    UserControl_KeyUp KeyCode, Shift
End Sub

Private Sub lstSort_LostFocus()
'   ****************************************************************************
'   * Purpose:  Fires when the listbox loses focus. This will fire the lostfocus
'   *               event for the usercontrol. There is a bug in the scrollbars
'   *               that allow the scrollbars to get focus even when the tabstop
'   *               property is set to false. This gets around that.
'   ****************************************************************************
    UserControl_LostFocus
End Sub

Private Sub m_oColumnHeaders_ColumnHeaderChanged(ColumnHeader As GTColumnHeader, sProperty As String)
'   ***********************************************************************
'   * Params:   ColumnHeader: the GTColumnHeader object that was changed, sProperty: the property that
'   *               was changed.
'   * Purpose:  Fired when a GTColumnHeader object is changed .
'   *               This is needed because there is no notification that the object was
'   *               changed.
'   ***********************************************************************
    Select Case sProperty
        Case "Width":
            If ColumnHeader.Index = 1 Then
                m_oListItems.ColumnHeaderWidth = ColumnHeader.InternalWidth
            End If
    End Select
    
    If Not ColumnHeader.Resize Then
        Paint Both
    End If
    
    If Not Ambient.UserMode Then
        PropertyChanged "Columns"
    End If
End Sub

Private Sub m_oColumnHeaders_ColumnHeaderRemoved(ColumnHeader As GTColumnHeader)
'   ***********************************************************************
'   * Params:   ColumnHeader: the GTColumnHeader object that was removed
'   * Purpose:  Fired when a GTColumnHeader object is removed from the ColumnHeaders collection.
'   *               This is needed because there is no notification that the object was
'   *               removed from the collection
'   ***********************************************************************
    If ColumnHeader Is Nothing Then
        Set m_oSelectedItem = Nothing
        m_oListItems.ResetNumHeaders ' reset the number of headers
        m_oListItems.Clear ' reinitialize the listitems.
    Else
        If ColumnHeader.Index = 1 And m_oColumnHeaders.Count > 1 Then
            m_oListItems.ColumnHeaderWidth = m_oColumnHeaders(ColumnHeader.Index + 1).InternalWidth
        End If
        m_oListItems.ColumnRemoved ' resets the dimensions in SubItems
    End If
    
    If m_iSortKey > m_oColumnHeaders.Count Then
        m_iSortKey = 1
    End If
    
    MakeScrollbarsVisible
    SetHScrollbarMax
    Paint Both
    
    If Not Ambient.UserMode Then
        PropertyChanged "Columns"
    End If
End Sub

Private Sub m_oListItems_ListItemChanged(ListItem As GTListItem, sProperty As String)
'   ***********************************************************************
'   * Params:   ListItem: the GTListItem object that was changed, sProperty: the property that
'   *               was changed.
'   * Purpose:  Fired when a GTListItem object is changed .
'   *               This is needed because there is no notification that the object was
'   *               changed.
'   ***********************************************************************
    Select Case sProperty
        Case "Selected"
            If Not m_bMultiSelect Or m_oSelectedItem Is Nothing Then
                Set m_oSelectedItem = ListItem
                Set m_oLastSelected = ListItem
            End If
            Paint Rows
        Case Else
            Paint Rows
    End Select
End Sub


Private Sub m_oListItems_ListItemRemoved(ListItem As GTListItem)
'   ***********************************************************************
'   * Params:   ListItem: the GTListItem object that was removed
'   * Purpose:  Fired when a GTListItem object is removed from the ListItems collection.
'   *               This is needed because there is no notification that the object was
'   *               removed from the collection
'   * Modified: Ver 1.0a    Added code to reset the selected item when listitems
'   *                               are cleared.
'   ***********************************************************************
    If ListItem Is Nothing Then
        Set m_oSelectedItem = Nothing
    Else
        SetHScrollbarMax
        MakeScrollbarsVisible
    End If
    
    Paint Rows
End Sub

Private Sub scrLR_Change()
'   ***********************************************************************
'   * Purpose:  Fired when the scroll buttons are clicked. Resets
'   *               the scrolloffset for the horizontal scrollbar.
'   ***********************************************************************
    
    m_oListItems.ScrollHOffset = scrLR.Value
    m_oColumnHeaders.ScrollOffset = scrLR.Value
    If Not m_bSkip Then
        Paint Both
    End If
    
End Sub

Private Sub scrLR_KeyDown(KeyCode As Integer, Shift As Integer)
'   ***********************************************************************
'   * Purpose:  Fired on keydown. This is passed to the usercontrol
'   *               event.
'   ***********************************************************************
    If KeyCode = vbKeyDown Or KeyCode = vbKeyUp Then
        UserControl_KeyDown KeyCode, Shift
        KeyCode = 0
    End If
End Sub

Private Sub scrLR_Scroll()
'   ***********************************************************************
'   * Purpose:  Fired when the Thumb is dragged. Resets
'   *               the scrolloffset for the horizontal scrollbar.
'   ***********************************************************************
    m_oListItems.ScrollHOffset = scrLR.Value
    m_oColumnHeaders.ScrollOffset = scrLR.Value
    Paint Both
End Sub

Private Sub scrUD_Change()
'   ***********************************************************************
'   * Purpose:  Fired when the scroll buttons are clicked. Resets
'   *               the scrolloffset for the vertical scrollbar.
'   ***********************************************************************
    m_oListItems.ScrollVOffset = scrUD.Value
    Paint Rows
End Sub

Private Sub scrUD_KeyDown(KeyCode As Integer, Shift As Integer)
'   ***********************************************************************
'   * Purpose:  Fired on keydown. This is passed to the usercontrol
'   *               event.
'   ***********************************************************************
    UserControl_KeyDown KeyCode, Shift
    KeyCode = 0
End Sub

Private Sub scrUD_Scroll()
'   ***********************************************************************
'   * Purpose:  Fired when the Thumb is dragged. Resets
'   *               the scrolloffset for the vertical scrollbar.
'   ***********************************************************************
    m_bRedraw = False
    m_oListItems.ScrollVOffset = scrUD.Value
'    m_oListItems.ScrollVOffset = scrUD.Value * TextHeight("B")
    m_bRedraw = True
   Paint Rows
 End Sub

Private Sub UserControl_AmbientChanged(PropertyName As String)
'   ****************************************************************************
'   * Params:   PropertyName: the name of the property that was changed.
'   * Purpose:  Fires when one of the Ambient properties was changed.
'   ****************************************************************************
    Select Case PropertyName
        Case "ScaleUnits":
            CalculateScaleUnits
    End Select
End Sub

Private Sub UserControl_Click()
    RaiseEvent Click
End Sub

Private Sub UserControl_DblClick()
    RaiseEvent DblClick
End Sub

Private Sub UserControl_GotFocus()
'   ****************************************************************************
'   * Purpose:  Fires when the usercontrol gets focus. Sets the flag
'   *               to true. This is used when drawing the focus rect.
'   ****************************************************************************
    m_bHasFocus = True
    Paint Rows
End Sub

Private Sub UserControl_InitProperties()
'   *************************************************************************
'   * Purpose:  Intializes the property variables . This is fired when a
'   *               control is first instanciated.
'   *************************************************************************
    On Error Resume Next
    
    m_bRedraw = False
        
'   ***** Ver 1.0a No longer used
''   ***** Turns on subclassing at runtime depending on the switch which is
''   ***** set in the make tab of Project Properties
'#If DEBUG_SWITCH = 2 Then
'    GTMsgHook1.Subclass = False
'#ElseIf DEBUG_SWITCH = 1 Then
'    GTMsgHook1.Subclass = Ambient.UserMode
'#Else
'    GTMsgHook1.Subclass = True
'#End If
''   *****
'   *****
    UserControl.Enabled = True ' ver 1.0a
    UserControl.BackColor = vbWindowBackground
    UserControl.ForeColor = vbButtonText
    m_lListItemForeColor = UserControl.ForeColor
    m_lColumnHeaderForeColor = UserControl.ForeColor
    m_bShowColumnHeaders = m_def_ShowColumnHeaders
    m_eSelType = GTListbox
    m_oListItems.SelectionType = m_eSelType
    m_bMultiSelect = False
    m_bSorted = False
    m_eSortOrder = gtAscending
    m_iSortKey = m_def_SortKey
    UserControl.MousePointer = vbDefault
    Set m_picMouseIcon = Nothing
    Set m_oColumnHeaderFont = Ambient.Font
    Set m_oListItemFont = Ambient.Font
    m_eBorderStyle = gtFixedSingle
    m_eAppearance = gt3D
    m_lColumnHeaderHeight = GetColumnHeaderHeight()
    m_oColumnHeaders.ColumnHeaderHeight = m_lColumnHeaderHeight
    
    m_oListItems.ColumnHeaderHeight = m_lColumnHeaderHeight
    m_lListItemHeight = GetListItemHeight()
    m_oListItems.TextHeight = m_lListItemHeight

'   ***** Calculates the scale units per pixel. The scaleunits are the scalemode of the container
    CalculateScaleUnits
'   *****

'   ***** Calculates the offset based on the borderstyle and appearance properties
    CalcOffset
'   *****
    m_bRedraw = True
    
    SetActiveFlag ' ver 1.0a
    
    Paint Both
    
    g_bAmbientUserMode = Ambient.UserMode
    
    SetSplitterProps

End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
'   *************************************************************************
'   * Purpose:  Fired when using the keyboard when the usercontrol
'   *               has focus. Sets the selected item(s) depending on
'   *               the shift/ctrl keys and MultiSelect property.
'   *************************************************************************
    Dim oTempItem As GTListItem
    Dim lChange As Long
    Dim oFirstVisible As GTListItem
    Dim oLastVisible As GTListItem
    Dim iNumVisible As Integer
    Dim lIndex As Long
    Dim lValue As Long
    
    
    If m_oSelectedItem Is Nothing Then
'   ***** No selected item exists yet
        Select Case KeyCode
            Case vbKeyDown:
                If m_oListItems.Count = 1 Then
                    Set m_oSelectedItem = m_oListItems(1)
                    m_oListItems(m_oSelectedItem.Index).Selected = True
                    Paint Rows
                ElseIf m_oListItems.Count > 1 Then
                    Set m_oSelectedItem = m_oListItems(2)
                    m_oListItems(m_oSelectedItem.Index).Selected = True
                    Paint Rows
                End If
            Case vbKeyLeft:
                SendKeys "{TAB}"
            Case vbKeyRight:
                SendKeys "+{TAB}"
        End Select
'   *****
    Else
'   ***** A listitem is selected already
        Select Case KeyCode
            Case vbKeyDown:
'   ***** This only happens when the selected item isn't the last listitem
'   ***** otherwise there is no place to go. This will scroll the display
'   ***** if when going to the last visible +1
                If Not (m_oSelectedItem.Index = m_oListItems.Count) Then
                    m_bRedraw = False ' turn off, operations are quicker
                    If Not (Shift = vbShiftMask) Then
                        m_oListItems(m_oSelectedItem.Index).Selected = False
                    End If
                    
                    Set m_oSelectedItem = m_oListItems(m_oSelectedItem.Index + 1)
                    m_oListItems(m_oSelectedItem.Index).Selected = True
                    
                    If scrUD.Visible Then
                        Set oTempItem = GetLastVisible()
                        If m_oSelectedItem Is oTempItem Then
                            If scrUD.Max >= scrUD.Value + scrUD.SmallChange Then
                                lChange = scrUD.Value + scrUD.SmallChange
                            Else
                                lChange = scrUD.Max
                            End If
                            scrUD.Value = lChange
                        End If
                    End If
                    m_bRedraw = True ' turn drawing back on
                    Paint Rows
                    RaiseEvent Click
                End If
'   *****
            Case vbKeyUp:
'   ***** This only happens when the selected item isn't the first listitem
'   ***** otherwise there is no place to go. This will scroll the display
'   ***** if when going to the first visible -1
                If Not (m_oSelectedItem.Index = 1) Then
                    m_bRedraw = False ' turn off, operations are quicker
                    If scrUD.Visible Then
                        Set oTempItem = GetFirstVisible()
                        If m_oSelectedItem Is oTempItem Then
                            If scrUD.Value - scrUD.SmallChange >= 0 Then
                                lChange = scrUD.Value - scrUD.SmallChange
                            Else
                                lChange = scrUD.Min
                            End If
                            scrUD.Value = lChange
                        End If
                    End If
                    
                    If Not (Shift = vbShiftMask) Then
                        m_oListItems(m_oSelectedItem.Index).Selected = False
                    End If
                    
                    Set m_oSelectedItem = m_oListItems(m_oSelectedItem.Index - 1)
                    m_oListItems(m_oSelectedItem.Index).Selected = True
                    
                    m_bRedraw = True ' turn drawing back on
                    Paint Rows
                    
                    RaiseEvent Click
                End If
'   *****
            Case vbKeyPageUp, vbKeyPageDown:
'   ***** Gets the first and last visible and finds the difference and multiplies
'   ***** by the textheight. This gives the number of amount to increase/decrease
'   ***** the scroll offset by
                m_bRedraw = False ' turn off, operations are quicker
                If Not m_oSelectedItem Is Nothing Then
                    m_oListItems(m_oSelectedItem.Index).Selected = False
                End If
                
                Set oFirstVisible = GetFirstVisible
                Set oLastVisible = GetLastVisible
                
                iNumVisible = oLastVisible.Index - oFirstVisible.Index
                
                If KeyCode = vbKeyPageDown Then
                    If Not scrUD.Visible Then
                        lIndex = m_oListItems.Count
                        lValue = 0
                    ElseIf scrUD.Value + (iNumVisible * m_lListItemHeight) < scrUD.Max Then
                        lIndex = m_oSelectedItem.Index + iNumVisible
                        lValue = scrUD.Value + (iNumVisible * m_lListItemHeight)
                    Else
                        lIndex = m_oListItems.Count
                        lValue = scrUD.Max
                    End If
                Else
                    If Not scrUD.Visible Then
                        lIndex = 1
                        lValue = 0
                    ElseIf scrUD.Value - (iNumVisible * m_lListItemHeight) > scrUD.Min Then
                        lIndex = m_oSelectedItem.Index - iNumVisible
                        lValue = scrUD.Value - (iNumVisible * m_lListItemHeight)
                    Else
                        lIndex = 1
                        lValue = scrUD.Min
                    End If
                End If
                
'   ***** Sets the selected property of the newly selected item and sets this
'   ***** to the selected item.
                m_oListItems(lIndex).Selected = True
                Set m_oSelectedItem = m_oListItems(lIndex)
                scrUD.Value = lValue
                m_bRedraw = True ' turn drawing back on
'   *****
                Paint Rows
'   *****
            Case vbKeyHome, vbKeyEnd:
'   ***** Sets the scroll offset to the min or max depending on the key that was
'   ***** was hit.
                m_bRedraw = False ' turn off, operations are quicker
                                
                If Not m_oSelectedItem Is Nothing And Not (Shift = vbShiftMask) Then
                    m_oListItems(m_oSelectedItem.Index).Selected = False
                End If
            
                If KeyCode = vbKeyHome Then
                    If Not scrUD.Visible Then
                        lIndex = 1
                        lValue = 0
                    Else
                        lIndex = 1
                        lValue = scrUD.Min
                    End If
                Else
                    If Not scrUD.Visible Then
                        lIndex = m_oListItems.Count
                        lValue = 0
                    Else
                        lIndex = m_oListItems.Count
                        lValue = scrUD.Max
                    End If
                End If
                
                m_oListItems(lIndex).Selected = True
                Set m_oSelectedItem = m_oListItems(lIndex)
                scrUD.Value = lValue
                
                If Shift = vbShiftMask Then
                    FindItemsToSelect
                End If
                
                m_bRedraw = True ' turn drawing back on
            
                Paint Rows
'   *****
            Case vbKeyLeft:
                SendKeys "{TAB}"
            Case vbKeyRight:
                SendKeys "+{TAB}"
            Case Else:
        
        End Select
'   *****
    End If
    
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub UserControl_LostFocus()
'   ****************************************************************************
'   * Purpose:  Fires when the usercontrol loses focus. Sets the flag
'   *               to false. This is used when drawing the focus rect.
'   ****************************************************************************
    m_bHasFocus = False
    Paint Rows
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
'   ****************************************************************************
'   * Purpose:  Fires when the Mouse is down. This will determine if
'   *               a ColumnHeader is clicked on and if it is being resized,
'   *               or if a listitem is being clicked on.
'   ****************************************************************************
    Dim lRet As Long
    Dim oHeader As GTColumnHeader
    Dim oListItem As GTListItem
    
'   ***** gets the columnheader the mouse is over. Nothing if not over
'   ***** one
    Set m_oActiveColumnHeader = m_oColumnHeaders.HitTest(x, y)
'   *****

'   ***** Checks to see if between 2 columnheaders. Nothing if not
    Set oHeader = m_oColumnHeaders.ColumnResize(x, y)
'   *****
    
'   ***** If the mouse is between 2 headers, want to put in resize mode
    If Not oHeader Is Nothing Then
        lRet = SetCapture(hWnd)
        m_lResizeCol = oHeader.Index
        m_oColumnHeaders(oHeader.Index).Resize = True
        Set m_oActiveColumnHeader = oHeader
        m_oActiveColumnHeader.Resize = True
        m_CSplitter.MouseDown 0, CLng(m_iOffset), x, y
        Exit Sub
    End If
'   *****

    RaiseEvent MouseDown(Button, Shift, x * m_iScalePerPixel, y * m_iScalePerPixel)
        
    If Button = vbLeftButton Then
        If Not m_oActiveColumnHeader Is Nothing Then
            m_bMouseDown = True
        End If
        
'   ***** only hittest for listitems when the activecolumnheader is nothing
        If m_oActiveColumnHeader Is Nothing Then
            Set oListItem = m_oListItems.HitTest(x, y)
            If oListItem Is Nothing Then
                Exit Sub
            End If
        End If
'   *****
        m_bRedraw = False
        
        If m_oActiveColumnHeader Is Nothing Then
'   ***** When a selected item already exist
            If Not m_oSelectedItem Is Nothing Then
'   ***** check the multiselect property and the shift and ctrl keys.
                If m_bMultiSelect Then
                    Select Case Shift
                        Case vbShiftMask:
                            
                        Case vbCtrlMask:
                            Set m_oSelectedItem = oListItem
                            m_oListItems(m_oSelectedItem.Index).Selected = Not _
                                    m_oListItems(m_oSelectedItem.Index).Selected
                            m_bRedraw = True
                        
                            Paint Rows
                            Exit Sub
                        Case Else:
                            m_oListItems.ResetSelected
                    End Select
                Else
                    m_oListItems(m_oSelectedItem.Index).Selected = False
                End If
            End If
'   *****
    End If
    
'   ***** Set the listitem to the selected listitem, but only when not over
'   ***** a columnheader
        If m_oActiveColumnHeader Is Nothing Then
            Set m_oSelectedItem = oListItem
        End If
'   *****
        m_bRedraw = True
        
'   ***** Repaint the control
        If Not m_oActiveColumnHeader Is Nothing Then
            Paint Columns
        ElseIf Not m_oSelectedItem Is Nothing Then
            RaiseEvent ListItemClick(m_oSelectedItem)
            If m_bMultiSelect And (Shift And vbShiftMask) Then
                FindItemsToSelect
                Paint Rows
            Else
                m_oListItems(m_oSelectedItem.Index).Selected = True
            End If
            
            Set m_oLastSelected = m_oSelectedItem
        End If
'   *****
    End If
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
'   ****************************************************************************
'   * Purpose:  Fires when the Mouse is moved over the user control.
'   *               If between 2 columns changes the mousepointer to the
'   *               splitter icon. If the left mousebutton is down (Button = 1)
'   *               then the splitter rect is drawn and moved.
'   ****************************************************************************
    Dim lTemp As Long
    Dim i As Long
    Dim oHeader As GTColumnHeader
    
    If Button And vbLeftButton Then
        
        If m_oActiveColumnHeader Is Nothing Then
            Set oHeader = m_oColumnHeaders.HitTest(x, y)
            If m_bMouseDown Then
                Set m_oActiveColumnHeader = oHeader
            End If
            If Not oHeader Is Nothing Then
                Paint Columns
            End If
        Else
            If m_oActiveColumnHeader.Resize Then
                m_CSplitter.MouseMove 0, CLng(m_iOffset), x, y
'   ***** this code will redraw the columns when sizing, no splitter rect. This is slower than the splitter rect
'                lTemp = (m_oColumnHeaders.GetColumnHeaderLeft(m_lResizeCol) + m_oColumnHeaders(m_lResizeCol).InternalWidth - scrLR.Value) - X
'
'                If m_oColumnHeaders(m_lResizeCol).InternalWidth - lTemp > 4 Then
'                    m_oColumnHeaders(m_lResizeCol).InternalWidth = m_oColumnHeaders(m_lResizeCol).InternalWidth - lTemp '- m_iOffset
'                Else
'                    m_oColumnHeaders(m_lResizeCol).InternalWidth = 4
'
'                End If
'
'                MakeScrollbarsVisible
'                SetHScrollbarMax
'
'                Paint All
'   *****
            Else
                Set oHeader = m_oColumnHeaders.HitTest(x, y)
                If m_bMouseDown Then
                    Set m_oActiveColumnHeader = oHeader
                End If
                Paint Columns
            End If
        
        End If
        
    Else
        If Not m_oColumnHeaders.ColumnResize(x, y) Is Nothing Then
            Set UserControl.MouseIcon = LoadResPicture(IDC_SPLITTER, vbResCursor)
            UserControl.MousePointer = vbCustom
        Else
            UserControl.MousePointer = m_eMousePointer
        End If
    End If
    
    RaiseEvent MouseMove(Button, Shift, x * m_iScalePerPixel, y * m_iScalePerPixel)
    
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
'   ****************************************************************************
'   * Purpose:  Fires when the Mouse is released. This will size the
'   *               the columns if a column was being resized. Otherwise
'   *               the columnheader will draw in the up position, or the
'   *               the listitem will highlight.
'   ****************************************************************************
    Dim lTemp As Long
    Dim oListItem As GTListItem
    
    Set oListItem = m_oListItems.HitTest(x, y)
    If oListItem Is Nothing And m_oActiveColumnHeader Is Nothing Then
        RaiseEvent MouseUp(Button, Shift, x * m_iScalePerPixel, y * m_iScalePerPixel)
        m_bMouseDown = False
        Exit Sub
    End If
    
    SetCapture 0 'release capture

'   ***** If the activecolumnheader is not nothing then check resize and resize the
'   ***** columnheader. Also fire the ColumnClick event.
    If Not m_oActiveColumnHeader Is Nothing Then
        If m_oActiveColumnHeader.Resize And m_CSplitter.MouseUp Then
            
            lTemp = (m_oColumnHeaders.GetColumnHeaderLeft(m_lResizeCol) + m_oColumnHeaders(m_lResizeCol).InternalWidth - scrLR.Value) - x
            
            If m_oColumnHeaders(m_lResizeCol).InternalWidth - lTemp > 4 Then
                m_oColumnHeaders(m_lResizeCol).InternalWidth = m_oColumnHeaders(m_lResizeCol).InternalWidth - lTemp
            Else
                m_oColumnHeaders(m_lResizeCol).InternalWidth = 4

            End If

            MakeScrollbarsVisible
            SetHScrollbarMax

            m_oColumnHeaders(m_lResizeCol).Resize = False
        End If
        
        If m_bMouseDown Then
            RaiseEvent ColumnClick(m_oActiveColumnHeader)
        End If
    End If
'   *****

    If Not m_oActiveColumnHeader Is Nothing Then
        Set m_oActiveColumnHeader = Nothing
        Paint Both
    End If
    
    RaiseEvent MouseUp(Button, Shift, x * m_iScalePerPixel, y * m_iScalePerPixel)
    
    m_bMouseDown = False
    
End Sub

Private Sub Paint(byArea As Byte, Optional bShowFocusRect As Boolean = True)
'   *********************************************************************************
'   * Params:   byArea: draw constant (all, columns, rows)
'   * Purpose:  Creates the memory dc to draw on or retrieves the
'   *               handle to it. If the param is Both, a new hdc is gotten, and
'   *               columns and rows are redrawn. If the param is column,
'   *               just the columns are redrawn. If Rows, just the listitem area
'   *               is redrawn.
'   *********************************************************************************
    Dim hDCMem As Long
    
    If Not m_bRedraw Then
        Exit Sub
    End If
    
'   ***** Only get a new dc when the whole control needs to be redrawn. Otherwise
'   ***** get the dc in memory
    If byArea = Both Then
        hDCMem = m_CPaint.GetMemDC(UserControl.hdc, ScaleWidth, ScaleHeight)
    Else
        hDCMem = m_CPaint.hDCMem
    End If
'   *****

    If byArea = Both Or byArea = Rows Then
        DrawListItemBackground hDCMem
    End If
    
    If Ambient.UserMode Then
'   ***** Draws the rows. Runtime only
        If byArea = Both Or byArea = Rows Then
            DrawRows hDCMem, IIf(scrLR.Visible, scrLR.Value, 0), scrUD.Value, m_bHasFocus And bShowFocusRect
        End If
'   *****
    Else
'   ***** Redraws the listitem background and prints the name of the control
        If m_oColumnHeaders.Count = 0 And m_oListItems.Count = 0 Then
            DrawListItemBackground hDCMem
            PrintDisplayName
        End If
'   *****
    End If
        
'   ***** Only draw the columns when they are to be shown
    If m_bShowColumnHeaders Then
        If byArea = Both Or byArea = Columns Then
            DrawColumns hDCMem, IIf(scrLR.Visible, scrLR.Value, 0)
        End If
    End If
'   *****

    DrawBorder hDCMem
    
'   ***** If both scrollbars are visible, draw the corner
    If IsHScrollbarVisible() And IsVScrollbarVisible() Then
        DrawCorner hDCMem
    End If
'   *****

    m_CPaint.BltMemDC UserControl.hdc, ScaleWidth, ScaleHeight

End Sub
Private Sub DrawColumns(hdc As Long, lVertOffset As Long)
Attribute DrawColumns.VB_MemberFlags = "40"
'   *********************************************************************************
'   * Params:   hDC: the dc to draw on, lVertOffset: how much the horizontal
'   *               scrollbar has scrolled.
'   * Purpose:  Draws the columns.
'   *********************************************************************************
    Dim i As Integer
    Dim rectHeaders As RECT
    Dim oColumnHeader As GTColumnHeader
    Dim lOptions As Long
    Dim sText As String
    Dim bDown As Boolean
    Dim lLeft As Long
    Dim lTop As Long
    Dim lOldBackColor As Long
    
    If m_oColumnHeaders.Count = 0 Then
        Exit Sub
    End If
    
'   ***** set the dcs font and forecolor
    Set UserControl.Font = m_oColumnHeaderFont
    UserControl.ForeColor = m_lColumnHeaderForeColor
'   *****

'   ***** Draws the backcolor for the columnheaders
    lOldBackColor = SetBkColor(hdc, GetSysColor(COLOR_BTNFACE))
    
    rectHeaders.Left = m_iOffset
    rectHeaders.Top = m_iOffset
    
    rectHeaders.Bottom = rectHeaders.Top + m_lColumnHeaderHeight
    rectHeaders.Right = ScaleWidth - m_iOffset
    
    ExtTextOut hdc, 0, 0, ETO_CLIPPED Or ETO_OPAQUE, rectHeaders, "", 0, 0
    lOldBackColor = SetBkColor(hdc, lOldBackColor)
'   *****

    lTop = m_iOffset
    lLeft = m_iOffset
    
'   ***** Draws the columnheaders using the scroll offset for positioning
    For Each oColumnHeader In m_oColumnHeaders
                
        If scrUD.Visible Then
            If lLeft - lVertOffset > ScaleWidth - m_iOffset - scrUD.Width Then
                Exit For
            End If
        ElseIf lLeft - lVertOffset > ScaleWidth - m_iOffset * 2 Then
            Exit For
        End If
        
'   ***** Only draws the columns when the visible property is true
        If oColumnHeader.Visible Then
            If m_oActiveColumnHeader Is oColumnHeader And Not oColumnHeader.Resize Then
                rectHeaders.Left = lLeft - lVertOffset + 1
                rectHeaders.Top = rectHeaders.Top + 1
                rectHeaders.Bottom = rectHeaders.Top + m_lColumnHeaderHeight
                rectHeaders.Right = rectHeaders.Left + oColumnHeader.InternalWidth
            Else
                rectHeaders.Left = lLeft - lVertOffset
                rectHeaders.Top = m_iOffset
                rectHeaders.Bottom = rectHeaders.Top + m_lColumnHeaderHeight
                rectHeaders.Right = rectHeaders.Left + oColumnHeader.InternalWidth
            End If
            
'   ***** Paints the text depending on the font and forecolor
            m_CPaint.PaintText oColumnHeader.Text, m_oColumnHeaderFont.Name, rectHeaders.Left, rectHeaders.Top, _
                        rectHeaders.Right, rectHeaders.Bottom, TextHeight("O"), DT_SINGLELINE Or DT_WORD_ELIPSE Or DT_VCENTER, _
                        oColumnHeader.Alignment, m_oColumnHeaderFont.Bold, m_oColumnHeaderFont.Italic, _
                        m_oColumnHeaderFont.Strikethrough, m_oColumnHeaderFont.Underline, GetBkColor(UserControl.hdc), _
                        GetTextColor(UserControl.hdc)
'   *****

            If m_oActiveColumnHeader Is Nothing Then
                bDown = oColumnHeader Is m_oActiveColumnHeader
            Else
                bDown = (oColumnHeader Is m_oActiveColumnHeader) And Not m_oActiveColumnHeader.Resize
            End If
            
            DrawColumnRect hdc, lLeft - lVertOffset, bDown, lTop, oColumnHeader
            
            lLeft = lLeft + oColumnHeader.InternalWidth
        
        End If
'   *****
    Next
    
    DrawColumnRect hdc, lLeft - lVertOffset, False, lTop

End Sub

Private Sub DrawColumnRect(hdc As Long, lLeft As Long, bDown As Boolean, lTop As Long, _
                                            Optional oColumnHeader As GTColumnHeader)
'   *********************************************************************************
'   * Params:   hDC: the dc to draw on, lLeft: the left of the column, bDown:
'   *               if the rect is to be drawn in the down position, lTop: the top of
'   *               of the column, oColumnHeader: Optional: the columnheader to
'   *               be drawn. If nothing, fills the rest of the header area with a blank
'   *               header.
'   * Purpose:  Draws a raised rect when the column is normal, draws a flat rect
'   *               when the columnheader is in the down position.
'   *********************************************************************************
    Dim lWidth As Long
    
    If oColumnHeader Is Nothing Then ' fills the rest of the header line
        lWidth = ScaleWidth - (lLeft + m_iOffset)
        If lWidth < 1 Then
            Exit Sub
        End If
    Else
        lWidth = oColumnHeader.InternalWidth
    End If
    
    If bDown Then
        m_CDrawRect.Draw3DRect hdc, lLeft, lTop, lWidth, m_lColumnHeaderHeight, BtnDown
    Else
        m_CDrawRect.Draw3DRect hdc, lLeft, lTop, lWidth, m_lColumnHeaderHeight, Raised
    End If
    
End Sub


Private Sub m_oColumnHeaders_ColumnHeaderAdded(ColumnHeader As GTColumnHeader)
'   ***********************************************************************
'   * Params:   ColumnHeader: the GTColumnHeader object that was added
'   * Purpose:  Fired when a GTColumnHeader object is added to the ColumHeaders collection.
'   *               This is needed because there is no notification that the object was
'   *               added to the collection
'   ***********************************************************************
    Set UserControl.Font = m_oColumnHeaderFont
    
    If ColumnHeader.Index = 1 Then
        m_oListItems.ColumnHeaderWidth = ColumnHeader.InternalWidth
    End If

    m_oListItems.ColumnAdded
    Paint Both
    MakeScrollbarsVisible
    SetHScrollbarMax
    
    If Not Ambient.UserMode Then
        PropertyChanged "Columns"
    End If
End Sub

Private Sub DrawRows(hdc As Long, lHOffset As Long, lVOffset As Long, bDrawFocus As Boolean)
Attribute DrawRows.VB_MemberFlags = "40"
'   *********************************************************************************
'   * Params:   hDC: the dc to draw on, lHOffset: how far to the left the
'   *               columns are scrolled, lVOffset: how far to the down the
'   *               listitems are scrolled, bDrawFocus: Draw the focus rect when
'   *               true.
'   * Purpose:  Draws the rows, draws the highlighting, and draws the focus
'   *               rect. When looping thru, the listitems aren't drawn until they are
'   *               visible (viewable on the control) and the loop ends when the items
'   *               aren't visible anymore. Also doesn't draw columns that aren't visible
'   *               or are out of display range.The listitems always start in the
'   *               same spot at the top of the control.
'   *********************************************************************************
    Dim lHoldTop As Long
    Dim i As Integer
    Dim j As Long
    Dim rectCols As RECT
    Dim oListItem As GTListItem
    Dim oColumnHeader As GTColumnHeader
    Dim lForeColor As OLE_COLOR
    Dim lTemp As Long
    Dim lTextWidth As Long
    Dim sText As String
    Dim lOptions As Long
    Dim lLeft As Long
    Dim lTop As Long
    Dim lCurrentY As Long
    Dim bFirstRow As Boolean
    Dim oFirstVisibleColumn As GTColumnHeader
    Dim lOldTextColor As Long
    
    If m_oListItems.Count = 0 Then
        Exit Sub
    End If
    
'   ***** Sets the font and forecolor for the dc
    Set UserControl.Font = m_oListItemFont
    UserControl.ForeColor = m_lListItemForeColor
    lForeColor = m_lListItemForeColor
'   *****

    lLeft = m_iOffset
    lTop = m_lColumnHeaderHeight + m_iOffset
    
'   ***** Draws a focus rect around the first row when no items are selected
'   ***** and the control has focus.
    If bDrawFocus And m_oSelectedItem Is Nothing Then
        rectCols.Left = m_iOffset
        rectCols.Top = lTop - lVOffset
        rectCols.Bottom = rectCols.Top + m_lListItemHeight
        If m_eSelType = GTListbox Then
            rectCols.Right = rectCols.Left + (ScaleWidth - m_iOffset * 2)
            If IsVScrollbarVisible Then
                rectCols.Right = rectCols.Left + scrUD.Left - m_iOffset
            End If
        Else
            Set oFirstVisibleColumn = GetFirstVisibleHeader()
            If oFirstVisibleColumn Is Nothing Then
                Exit Sub
            End If
            
            If oFirstVisibleColumn.Alignment = gtLeftJustify Then
                If TextWidth(oListItem.Text) + 8 < oFirstVisibleColumn.InternalWidth Then
                    rectCols.Right = rectCols.Left + TextWidth(oListItem.Text) + 8
                Else
                    rectCols.Right = rectCols.Left + oFirstVisibleColumn.InternalWidth
                End If
            Else
                rectCols.Right = rectCols.Left + oFirstVisibleColumn.InternalWidth
            End If
        End If
        
        lOldTextColor = SetTextColor(hdc, GetTextColor(UserControl.hdc))
        DrawFocusRect hdc, rectCols
        SetTextColor hdc, lOldTextColor
    End If
'   *****

    bFirstRow = True
    
'   ***** Draws the rows. The first visible row is always draw at the same y value
    For Each oListItem In m_oListItems
        
        If (lTop - lVOffset) >= m_lColumnHeaderHeight + m_iOffset Then
            
            If bFirstRow Then
                bFirstRow = False
                lCurrentY = m_lColumnHeaderHeight + m_iOffset
            Else
                lCurrentY = lCurrentY + m_lListItemHeight
            End If
        
            If scrLR.Visible Then
                If (lCurrentY + m_lListItemHeight) > ScaleHeight - m_iOffset - scrLR.Height Then
                    Exit For
                End If
            ElseIf (lCurrentY + m_lListItemHeight) > ScaleHeight - m_iOffset + 1 Then
                Exit For
            End If
            
'   ***** Draws the row with the highlight color for selected row(s)
            If Not m_bMultiSelect Then
'   ***** MultiSelect
                If Not m_oSelectedItem Is Nothing Then
                    If m_oSelectedItem Is oListItem Then
'   ***** Draws a rect with the highlight color
                            SetBkColor hdc, GetSysColor(COLOR_HIGHLIGHT)
                            
'                            rectCols.Left = m_iOffset - lHOffset
                            rectCols.Top = lCurrentY
                            rectCols.Bottom = rectCols.Top + m_lListItemHeight '+ 1
                            
                            If m_eSelType = GTListbox Then
                                rectCols.Left = m_iOffset
                                rectCols.Right = rectCols.Left + (ScaleWidth - m_iOffset * 2)
                                If IsVScrollbarVisible Then
                                    rectCols.Right = rectCols.Left + scrUD.Left - m_iOffset
                                End If
                            Else
                                rectCols.Left = m_iOffset - lHOffset
'   ***** When SelectionStyle is ListView, have to get the first visible columnheader and then
'   ***** only draw the highlight the width of the text (but only when left justified) or the width
'   ***** of the column (when centered or right justified)
                                Set oFirstVisibleColumn = GetFirstVisibleHeader()
                                If oFirstVisibleColumn Is Nothing Then
                                    Exit Sub
                                End If
                                
                                If oFirstVisibleColumn.Alignment = gtLeftJustify Then
                                    If TextWidth(oListItem.Text) + 8 < oFirstVisibleColumn.InternalWidth Then
                                        rectCols.Right = rectCols.Left + TextWidth(oListItem.Text) + 8
                                    Else
                                        rectCols.Right = rectCols.Left + oFirstVisibleColumn.InternalWidth
                                    End If
                                Else
                                    rectCols.Right = rectCols.Left + oFirstVisibleColumn.InternalWidth
                                End If
                            End If
                            
                            ExtTextOut hdc, 0, 0, _
                                        ETO_CLIPPED Or ETO_OPAQUE, rectCols, "", 0, 0
'   *****

'   ***** Sets the colors and draws the focus rect. Have to set the correct colors or the
'   ***** focus rect doesn't draw correctly
                            lForeColor = UserControl.ForeColor
                            UserControl.ForeColor = vbHighlightText
                            
                            If bDrawFocus Then
                                lOldTextColor = SetTextColor(hdc, GetTextColor(UserControl.hdc))
                                DrawFocusRect hdc, rectCols
                                SetTextColor hdc, lOldTextColor
                            End If
'   *****
                    End If
                End If
'   *****
            Else
'   ***** Single select
                If oListItem.Selected Then
'   ***** Draws a rect with the highlight color
                        SetBkColor hdc, GetSysColor(COLOR_HIGHLIGHT)
                        
'                        rectCols.Left = m_iOffset - lHOffset
                        rectCols.Top = lCurrentY
                        rectCols.Bottom = rectCols.Top + m_lListItemHeight '+ 1
                        If m_eSelType = GTListbox Then
                            rectCols.Left = m_iOffset
                            rectCols.Right = rectCols.Left + (ScaleWidth - m_iOffset * 2)
                        Else
                            rectCols.Left = m_iOffset - lHOffset
'   ***** When SelectionStyle is ListView, have to get the first visible columnheader and then
'   ***** only draw the highlight the width of the text (but only when left justified) or the width
'   ***** of the column (when centered or right justified)
                            Set oFirstVisibleColumn = GetFirstVisibleHeader()
                            If oFirstVisibleColumn Is Nothing Then
                                Exit Sub
                            End If
                            
                            If oFirstVisibleColumn.Alignment = gtLeftJustify Then
                                If TextWidth(oListItem.Text) + 8 < oFirstVisibleColumn.InternalWidth Then
                                    rectCols.Right = rectCols.Left + TextWidth(oListItem.Text) + 8
                                Else
                                    rectCols.Right = rectCols.Left + oFirstVisibleColumn.InternalWidth
                                End If
                            Else
                                rectCols.Right = rectCols.Left + oFirstVisibleColumn.InternalWidth
                            End If
'   *****
                        End If
                        
                        ExtTextOut hdc, 0, 0, _
                                    ETO_CLIPPED Or ETO_OPAQUE, rectCols, "", 0, 0
'   *****

'   ***** Sets the colors and draws the focus rect. Have to set the correct colors or the
'   ***** focus rect doesn't draw correctly
                        lForeColor = UserControl.ForeColor
                        UserControl.ForeColor = vbHighlightText
                        
                        If m_oSelectedItem Is oListItem Then
                            If IsVScrollbarVisible And m_eSelType = GTListbox Then
                                rectCols.Right = rectCols.Left + scrUD.Left - m_iOffset
                            End If
                            If bDrawFocus Then
                                lOldTextColor = SetTextColor(hdc, GetTextColor(UserControl.hdc))
                                DrawFocusRect hdc, rectCols
                                SetTextColor hdc, lOldTextColor
                            End If
                        End If
'   *****
                End If
'   *****
            End If
'   *****

            For Each oColumnHeader In m_oColumnHeaders
                        
                If scrUD.Visible Then
                    If lLeft + m_iOffset - lHOffset > ScaleWidth - m_iOffset - scrUD.Width Then
                        Exit For
                    End If
                ElseIf lLeft + m_iOffset - lHOffset > ScaleWidth - m_iOffset * 2 Then
                    Exit For
                End If
                
'   ***** Only draws the listitems when the columnheader is visible
                If oColumnHeader.Visible Then
                
                    If lLeft + oColumnHeader.InternalWidth - lHOffset > 0 Then
'   ***** Draws the text property (first column) or subitems (when a column other than one)
                        If oColumnHeader.Index = 1 Then
                            sText = oListItem.Text
                        Else
                            sText = oListItem.SubItems(oColumnHeader.SubItemIndex)
                        End If
'   *****
                        rectCols.Left = lLeft - lHOffset
                        rectCols.Top = lCurrentY
                        rectCols.Bottom = rectCols.Top + m_lListItemHeight
                        rectCols.Right = rectCols.Left + oColumnHeader.InternalWidth
                
'   ***** Ver 1.0a Added support for font attributes
                        m_CPaint.PaintText sText, UserControl.Font.Name, rectCols.Left, rectCols.Top, rectCols.Right, _
                                        rectCols.Bottom, TextHeight("O"), DT_SINGLELINE Or DT_WORD_ELIPSE, oColumnHeader.Alignment, _
                                        m_oListItemFont.Bold, m_oListItemFont.Italic, m_oListItemFont.Strikethrough, m_oListItemFont.Underline, _
                                        GetBkColor(UserControl.hdc), GetTextColor(UserControl.hdc)
'                        m_CPaint.PaintText sText, UserControl.Font.Name, rectCols.Left, rectCols.Top, rectCols.Right, _
'                                        rectCols.Bottom, TextHeight("O"), DT_SINGLELINE Or DT_WORD_ELIPSE, oColumnHeader.Alignment, _
'                                        , , , , GetBkColor(UserControl.hdc), GetTextColor(UserControl.hdc)
'   *****
                    End If
                    
                    If oColumnHeader.Index = 1 Then
                        If m_eSelType = gtListView Then
                            UserControl.ForeColor = lForeColor
                        End If
                    End If
                    
                    lLeft = lLeft + oColumnHeader.InternalWidth
                End If
'   *****
            Next
        
        End If

        lLeft = m_iOffset ' reset the left counter
        
        UserControl.ForeColor = lForeColor
        
        lTop = lTop + m_lListItemHeight
    Next
End Sub

Private Sub m_oListItems_ListItemAdded(ListItem As GTListItem)
'   ***********************************************************************
'   * Params:   ListItem: the GTListItem object that was added
'   * Purpose:  Fired when a GTListItem object is added to the ListItems collection.
'   *               This is needed because there is no notification that the object was
'   *               added to the collection
'   ***********************************************************************
    
    If m_bRedraw Then
        MakeScrollbarsVisible
        SetHScrollbarMax
    End If
    
    If m_bSorted Then
        SortByColumn
    End If
    
    Paint Rows
End Sub

Private Sub UserControl_Initialize()
'   ****************************************************************************
'   * Purpose:  Fires when the control is first instiated. The control has not
'   *               yet been sited on the container. Initalizes certain variables and Messages
'   *               are added to be intercepted.
'   ****************************************************************************
'   ***** Ver 1.0a No longer used
'    Dim oWindow As GTWindow
'   *****
    On Error Resume Next
    
    Set m_oListItems = New GTListItems
    Set m_oColumnHeaders = New GTColumnHeaders
    
    Set m_CPaint = New CPaint
    Set m_CDrawRect = New CDrawRect
    
    Set m_CSplitter = New CSplitter
    m_CSplitter.ParentHwnd = UserControl.hWnd
    m_CSplitter.Orientation = 0 ' vertical
    m_CSplitter.Width = 2
    
'   ***** Ver 1.0a No longer used
''   ***** Want to subclass the ourselves
'    Set oWindow = GTMsgHook1.Windows.Add(, , , UserControl.hWnd)
'    If Not oWindow Is Nothing Then
'        oWindow.Messages.Add , , WM_SYSCOLORCHANGE, "WM_SYSCOLORCHANGE"
'    End If
''   *****
'   *****
    SetScrollMetrics
    m_bRedraw = True
End Sub

Private Sub UserControl_Paint()
'   **************************************************************
'   * Purpose:  Fired when the control needs to be repainted.
'   *               Calls the internal Paint proc.
'   **************************************************************
    Paint Both
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
'   *************************************************************************
'   * Purpose:  Retrieves the properties from the property bag for those
'   *               properties that can be set at designtime or thru the proppages.
'   *               The control is sited on the container that is point.
'   *************************************************************************
    m_bRedraw = False
    
    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H80000005)
    UserControl.ForeColor = PropBag.ReadProperty("ForeColor", Ambient.ForeColor)
    m_lListItemForeColor = UserControl.ForeColor
    m_lColumnHeaderForeColor = PropBag.ReadProperty("ColumnHeaderForeColor", Ambient.ForeColor)
    
    m_eAppearance = PropBag.ReadProperty("Appearance", gt3D)
    m_eBorderStyle = PropBag.ReadProperty("BorderStyle", gtFixedSingle)
    
    m_bMultiSelect = PropBag.ReadProperty("MultiSelect", False)
    m_eSortOrder = PropBag.ReadProperty("SortOrder", gtAscending)
    m_iSortKey = PropBag.ReadProperty("SortKey", m_def_SortKey)
    m_bSorted = PropBag.ReadProperty("Sorted", False)
    
    m_bShowColumnHeaders = PropBag.ReadProperty("ShowColumnHeaders", m_def_ShowColumnHeaders)
    
'   ***** Ver 1.0a Enabled property now persists
    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
'   *****

    m_eMousePointer = PropBag.ReadProperty("MousePointer", vbDefault)
    UserControl.MousePointer = m_eMousePointer
    
    Set m_picMouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
    Set UserControl.MouseIcon = m_picMouseIcon
    
    Set m_oColumnHeaderFont = PropBag.ReadProperty("ColumnHeaderFont", Ambient.Font)
    Set m_oListItemFont = PropBag.ReadProperty("Font", Ambient.Font)
    
    m_eSelType = PropBag.ReadProperty("SelectionType", GTListbox)
    
    m_oListItems.SelectionType = m_eSelType
    
    m_lColumnHeaderHeight = GetColumnHeaderHeight()
    m_oColumnHeaders.ColumnHeaderHeight = m_lColumnHeaderHeight
    m_oListItems.ColumnHeaderHeight = m_lColumnHeaderHeight
    
    m_lListItemHeight = GetListItemHeight()
    m_oListItems.TextHeight = m_lListItemHeight
    
'   ***** Calculates the scale units per pixel. The scaleunits are the scalemode of the container
    CalculateScaleUnits
'   *****

'   ***** Calculates the offset based on the borderstyle and appearance properties
    CalcOffset
'   *****
    
    ReadObjectProps PropBag
    
'   ***** Ver 1.0a No longer used
'   ***** Turns on subclassing at runtime depending on the switch which is
'   ***** set in the make tab of Project Properties
'#If DEBUG_SWITCH = 2 Then
'    GTMsgHook1.Subclass = False
'#ElseIf DEBUG_SWITCH = 1 Then
'    GTMsgHook1.Subclass = Ambient.UserMode
'#Else
'    GTMsgHook1.Subclass = True
'#End If
'   *****
'   *****
    m_bRedraw = True
    
    SetActiveFlag ' ver 1.0a

    Paint Both
    
    SetSplitterProps
    
    g_bAmbientUserMode = Ambient.UserMode

    Timer1.Enabled = Ambient.UserMode ' ver 1.0a
End Sub

Private Sub UserControl_Resize()
'   **************************************************************************
'   * Purpose:  Fired when the control is resized. Redraws the columns
'   *               and listitems. Also redetermines if the scrollbars need
'   *               to be visible.
'   **************************************************************************
    SetSplitterProps
    m_oListItems.ScaleHeight = ScaleHeight
    MakeScrollbarsVisible
    SetHScrollbarMax
    
    Paint Both
End Sub

Private Sub UserControl_Terminate()
'   **************************************************************************
'   * Purpose:  Fired when the control is destroyed gracefully. Doesn't
'   *               occur when the user hits Stop or end. Releases all objects.
'   *               and cleans up.
'   **************************************************************************
'   ***** Ver 1.0a No longer used
'    GTMsgHook1.Subclass = False
'   *****
    Set m_oListItems = Nothing
    Set m_oColumnHeaders = Nothing
    Set m_CDrawRect = Nothing
    Set m_CSplitter = Nothing
    Set m_CPaint = Nothing
End Sub
Private Sub PrintDisplayName()
'   **************************************************************************
'   * Purpose:  Draws the name of the control at design time when
'   *               there are no columns. Lets the user see it's not another
'   *               type of control.
'   **************************************************************************
    Dim r As RECT
    r.Left = m_iOffset
    r.Top = m_iOffset
    r.Bottom = r.Top + TextHeight("O") + 4
    r.Right = r.Left + TextWidth(Ambient.DisplayName) + 2

    If Not m_oListItemFont Is Nothing Then
        m_CPaint.PaintText Ambient.DisplayName, m_oListItemFont.Name, r.Left, r.Top, r.Right, r.Bottom, TextHeight("O"), _
            DT_SINGLELINE Or DT_VCENTER, , m_oListItemFont.Bold, m_oListItemFont.Italic, m_oListItemFont.Strikethrough, m_oListItemFont.Underline, _
            , m_lListItemForeColor
    End If
    
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
'   **************************************************************************
'   * Purpose:  Fired at designtime when properties have been changed.
'   *               Saves the properties in the property bag.
'   **************************************************************************
    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, Ambient.BackColor)
    Call PropBag.WriteProperty("ForeColor", m_lListItemForeColor, Ambient.ForeColor)
    Call PropBag.WriteProperty("ColumnHeaderForeColor", m_lColumnHeaderForeColor, Ambient.ForeColor)
    Call PropBag.WriteProperty("SelectionType", m_eSelType, GTListbox)
    Call PropBag.WriteProperty("MultiSelect", m_bMultiSelect, False)
    Call PropBag.WriteProperty("SortOrder", m_eSortOrder, gtAscending)
    Call PropBag.WriteProperty("SortKey", m_iSortKey, m_def_SortKey)
    Call PropBag.WriteProperty("Sorted", m_bSorted, False)
    Call PropBag.WriteProperty("MousePointer", m_eMousePointer, vbDefault)
    Call PropBag.WriteProperty("MouseIcon", m_picMouseIcon, Nothing)
    Call PropBag.WriteProperty("ColumnHeaderFont", m_oColumnHeaderFont)
    Call PropBag.WriteProperty("Font", m_oListItemFont)
    Call PropBag.WriteProperty("Appearance", m_eAppearance, gt3D)
    Call PropBag.WriteProperty("BorderStyle", m_eBorderStyle, gtFixedSingle)
    Call PropBag.WriteProperty("ShowColumnHeaders", m_bShowColumnHeaders, m_def_ShowColumnHeaders)
'   ***** Ver 1.0a Enabled property now persists
    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
'   *****
    If Not Ambient.UserMode Then
        WriteObjectProps PropBag
    End If
End Sub
Private Sub DrawCorner(hdc As Long)
'   **************************************************************************
'   * Param:    hDC: the dc to draw on.
'   * Purpose:  When the horizontal and vertical scrollbars are visible,
'   *               a grey rect will draw. If the control is within 2 pixels of
'   *               the bottom right corner, grab handles will draw instead.
'   **************************************************************************
    Dim rectCorner As RECT
    
    On Error GoTo DrawCorner_err
    
    SetBkColor hdc, GetSysColor(COLOR_BTNFACE)
    
    rectCorner.Left = scrUD.Left
    rectCorner.Top = scrLR.Top
    rectCorner.Bottom = rectCorner.Top + (ScaleHeight - rectCorner.Top - m_iOffset)
    rectCorner.Right = rectCorner.Left + (ScaleWidth - rectCorner.Left - m_iOffset)
    
    If (UserControl.Height >= Parent.ScaleHeight - (2 * m_iScalePerPixel) And UserControl.Height <= Parent.ScaleHeight) And _
        (UserControl.Width >= Parent.ScaleWidth - (2 * m_iScalePerPixel) And UserControl.Width <= Parent.ScaleWidth) Then
        DrawFrameControl hdc, rectCorner, DFC_SCROLL, DFCS_SCROLLSIZEGRIP
    Else
        ExtTextOut hdc, rectCorner.Left, rectCorner.Top, ETO_CLIPPED Or ETO_OPAQUE, rectCorner, "", 0, 0
    End If
    
    Exit Sub
    
DrawCorner_err:
    On Error Resume Next
    ExtTextOut hdc, rectCorner.Left, rectCorner.Top, ETO_CLIPPED Or ETO_OPAQUE, rectCorner, "", 0, 0
End Sub

Private Sub MakeScrollbarsVisible()
'   **************************************************************************
'   * Purpose: Determines if the 1 or both scrollbars will be visible.
'   *               The scrollbars are moved into position before becoming
'   *               visible.
'   **************************************************************************
    If IsHScrollbarVisible() And IsVScrollbarVisible() Then
        scrUD.Move ScaleWidth - scrUD.Width - m_iOffset, m_iOffset, scrUD.Width, ScaleHeight - scrLR.Height - m_iOffset * 2
        scrLR.Move m_iOffset, (ScaleHeight - m_iOffset) - scrLR.Height, ScaleWidth - scrUD.Width - m_iOffset * 2, scrLR.Height
    ElseIf IsHScrollbarVisible() Then
        scrLR.Move m_iOffset, (ScaleHeight - m_iOffset) - scrLR.Height, (ScaleWidth - m_iOffset * 2), scrLR.Height
    ElseIf IsVScrollbarVisible() Then
        scrUD.Move ScaleWidth - scrUD.Width - m_iOffset, m_iOffset, scrUD.Width, ScaleHeight - m_iOffset * 2
    End If
        
    scrLR.Visible = (m_oColumnHeaders.GetMaxWidth > (ScaleWidth - m_iOffset))
    
    If m_oColumnHeaders.Count > 0 Then
        If Not scrLR.Visible Then
            m_bSkip = True
            scrLR.Value = 0
            m_bSkip = False
        End If
    End If
    
    If m_oListItems.Count > 0 Then
       scrUD.Visible = (m_oListItems.GetListItemTop(m_oListItems.Count) + m_lListItemHeight + m_lColumnHeaderHeight > ScaleHeight)
    End If
End Sub
Private Function IsVScrollbarVisible() As Boolean
'   **************************************************************************
'   * Return:   Boolean: True: the vertical scrollbar needs to be visible, False:
'   *               don't show the scrollbar
'   * Purpose:  Checks to see if there are more listitems than can
'   *               be displayed and returns True if so.
'   **************************************************************************
    If m_oListItems.Count > 0 Then
        IsVScrollbarVisible = (m_oListItems.GetListItemTop(m_oListItems.Count) + m_lListItemHeight + m_lColumnHeaderHeight > ScaleHeight)
    End If
End Function
Private Function IsHScrollbarVisible() As Boolean
'   **************************************************************************
'   * Return:   Boolean: True: the horizontal scrollbar needs to be visible, False:
'   *               don't show the scrollbar
'   * Purpose:  Checks to see if there are more columns than can
'   *               be displayed and returns True if so.
'   **************************************************************************
    If m_oColumnHeaders.Count > 0 Then
        IsHScrollbarVisible = (m_oColumnHeaders.GetMaxWidth() > ScaleWidth - m_iOffset)
    End If
End Function
Private Sub SetHScrollbarMax()
'   **************************************************************************
'   * Purpose:  After adding columns, the max property of the horizontal
'   *               scrollbar is reset.
'   **************************************************************************
    If m_oColumnHeaders.Count = 0 Then
        Exit Sub
    End If
    
    scrLR.Max = m_oColumnHeaders.GetMaxWidth()
    
    If scrLR.Max - ScaleWidth + m_iOffset > 0 Then
        scrLR.Max = scrLR.Max - ScaleWidth + m_iOffset
        If scrUD.Visible Then
            scrLR.Max = scrLR.Max + scrUD.Width
        End If
    End If
    
'   ***** Sets the small and large changed based on the max
    If scrLR.Max \ (m_oColumnHeaders.Count * 2) = 0 Then
        scrLR.SmallChange = 1
    Else
        scrLR.SmallChange = scrLR.Max \ (m_oColumnHeaders.Count * 2)
    End If
    
    If scrLR.Max \ m_oColumnHeaders.Count <= m_oColumnHeaders.Count Then
        scrLR.LargeChange = scrLR.Max
    Else
        scrLR.LargeChange = scrLR.Max \ m_oColumnHeaders.Count
    End If
'   *****

    SetVScrollbarMax
End Sub
Private Sub SetVScrollbarMax()
'   **************************************************************************
'   * Purpose:  After adding listitems, the max property of the vertical
'   *               scrollbar is reset.
'   **************************************************************************
    If m_oListItems.Count = 0 Then
        Exit Sub
    End If
    
    scrUD.SmallChange = m_lListItemHeight
    scrUD.LargeChange = scrUD.SmallChange * 4
    
    scrUD.Max = m_oListItems.Count * scrUD.SmallChange
    
    If scrUD.Visible Then
        scrUD.Max = scrUD.Max - (ScaleHeight - (m_lColumnHeaderHeight + m_iOffset * 2))
    End If
    If scrLR.Visible Then
        scrUD.Max = scrUD.Max + scrLR.Height
    End If
    
End Sub
Public Function GetFirstVisible() As GTListItem
Attribute GetFirstVisible.VB_Description = "Retrieves a reference of the first item visible in the client area."
Attribute GetFirstVisible.VB_HelpID = 130
'   **************************************************************************
'   * Return:   GTListItem: the first listitem visible in the control, or nothing
'   *               if none.
'   * Purpose:  Loops thru to find the first visible listitem, taking into
'   *               account the scroll offset.
'   **************************************************************************
    Dim oListItem As GTListItem
    Dim i As Long
    Dim lTop As Long
    
    lTop = m_lColumnHeaderHeight + m_iOffset
    
    For Each oListItem In m_oListItems
        
        If lTop >= m_lColumnHeaderHeight + (scrUD.Value) Then
            Set GetFirstVisible = oListItem
            Exit Function
        End If
        
        lTop = lTop + m_lListItemHeight
    Next
    
    Set GetFirstVisible = m_oListItems(1)

End Function
Public Function GetLastVisible() As GTListItem
Attribute GetLastVisible.VB_Description = "Retrieves a reference of the last item visible in the client area."
Attribute GetLastVisible.VB_HelpID = 131
'   **************************************************************************
'   * Return:   GTListItem: the last listitem visible in the control, or nothing
'   *               if none.
'   * Purpose:  Loops thru to find the last visible listitem, taking into
'   *               account the scroll offset.
'   **************************************************************************
    Dim oListItem As GTListItem
    Dim i As Long
    Dim lBottom As Long
    Dim lTop As Long
    
    lBottom = ScaleHeight - m_iOffset + 1
    If IsHScrollbarVisible() Then
        lBottom = lBottom - scrLR.Height
    End If
    
    lTop = m_lColumnHeaderHeight + m_iOffset
    
    For Each oListItem In m_oListItems
        
        lTop = lTop + m_lListItemHeight
        
        If lTop > lBottom + scrUD.Value Then
            Set GetLastVisible = oListItem
            Exit Function
        End If
        
    Next
    
    Set GetLastVisible = m_oListItems(m_oListItems.Count)
    
End Function
Private Sub SetScrollMetrics()
'   **************************************************************************
'   * Purpose:  Gets the width and height of the scrollbuttons using the
'   *               GetSystemMetrics API and sets the height or width
'   *               of the vertical or horizontal scrollbars accordingly.
'   **************************************************************************
    Dim lRet As Long
    
    lRet = GetSystemMetrics(SM_CXHSCROLL)
    scrLR.Height = lRet
    
    lRet = GetSystemMetrics(SM_CXVSCROLL)
    scrUD.Width = lRet
    
End Sub

Private Sub SortByColumn()
'   **************************************************************************
'   * Purpose:  Loads lstSort with the items from the subitem or text
'   *               represented by the SortKey to set in order. OrderCollection
'   *               is called after the items are added.
'   **************************************************************************
    Dim oListItem As GTListItem
    Dim oColumnHeader As GTColumnHeader
    Dim i As Long
    Dim rc  As Boolean
    
    On Error GoTo SortByColumn_err
    
    If Not m_bRedraw Then
        Exit Sub
    End If
    
    If m_iSortKey = 0 Then
        Exit Sub
    End If
    
    lstSort.Clear ' clear items
    
    Set oColumnHeader = m_oColumnHeaders(m_iSortKey)
    
'   ***** Loads the items from the column into a listbox to do the sorting
    For Each oListItem In m_oListItems
        If oColumnHeader.SubItemIndex = 0 Then
            lstSort.AddItem oListItem.Text
        Else
            lstSort.AddItem oListItem.SubItems(oColumnHeader.SubItemIndex)
        End If
        lstSort.ItemData(lstSort.NewIndex) = oListItem.Index
    Next
'   *****

    OrderCollection
    
    Exit Sub
    
SortByColumn_err:
    MsgBox Err.Description, vbInformation
End Sub
Private Sub OrderCollection()
'   **************************************************************************
'   * Purpose:  Loads a temporary collection with the listitems in ascending
'   *               or descending order. Then replaces the collection in
'   *               in m_oListItems.
'   **************************************************************************
    Dim colTemp As Collection
    Dim i As Long
    
    On Error GoTo OrderCollection_err
    
    Set colTemp = New Collection
    
'   ***** Loads the sorted listitems into a temporary collection based on the
'   ***** order in the listbox
    If m_eSortOrder = gtAscending Then
        For i = 0 To lstSort.ListCount - 1
            colTemp.Add m_oListItems(lstSort.ItemData(i))
        Next
    Else
        For i = lstSort.ListCount - 1 To 0 Step -1
            colTemp.Add m_oListItems(lstSort.ItemData(i))
        Next
    End If
'   *****

    Set m_oListItems.ListItems = colTemp ' sets the collection
    
    Exit Sub
    
OrderCollection_err:
    MsgBox Err.Description, vbInformation
End Sub

Private Sub FindItemsToSelect()
'   **************************************************************************
'   * Purpose:  Unselects the selected items and selects new ones.
'   *               Redraw is turned off to speed things up.
'   **************************************************************************
    
    m_bRedraw = False
    m_oListItems.ResetSelected
    m_oListItems.SelectItems m_oSelectedItem, m_oLastSelected
    m_bRedraw = True
    
End Sub

Private Sub DrawBorder(hdc As Long)
'   *********************************************************************************
'   * Params:   hDC: the dc to draw on.
'   * Purpose:  Draws the border based on the Appearance and BorderStyle
'   *               properties.
'   *********************************************************************************
    If m_eAppearance = gt3D And m_eBorderStyle = gtFixedSingle Then
        m_CDrawRect.Draw3DRect hdc, 0, 0, ScaleWidth, ScaleHeight, Inset
    ElseIf m_eBorderStyle = gtFixedSingle Then
        m_CDrawRect.Draw3DRect hdc, 0, 0, ScaleWidth, ScaleHeight, FixedSingle
    End If
End Sub
Private Function GetColumnHeaderHeight() As Long
'   *********************************************************************************
'   * Return:   Long: the height of the columnheaders
'   * Purpose:  Calculates the columnheader height based on the font size.
'   *               Returns 0 when ShowColumnHeaders is False.
'   *********************************************************************************
    Dim oTempFont As Font
    
    If Not m_bShowColumnHeaders Then
        GetColumnHeaderHeight = 0
    Else
        On Error GoTo GetColumnHeaderheight_err
        Set oTempFont = UserControl.Font
        Set UserControl.Font = m_oColumnHeaderFont
        
        GetColumnHeaderHeight = TextHeight("B") + 4
        
        Set UserControl.Font = oTempFont
    End If
    
    Exit Function
    
GetColumnHeaderheight_err:
    If m_bShowColumnHeaders Then
        GetColumnHeaderHeight = TextHeight("B") ' pass back the current font's textheight
    Else
        GetColumnHeaderHeight = 0
    End If
End Function
Private Function GetListItemHeight() As Long
'   *********************************************************************************
'   * Return:   Long: the height of each listitem
'   * Purpose:  Calculates the listitem height based on the font size.
'   *********************************************************************************
    Dim oTempFont As Font
    
    On Error GoTo GetListItemHeight_err
    
    Set oTempFont = UserControl.Font
    Set UserControl.Font = m_oListItemFont
    
    GetListItemHeight = TextHeight("O")
    
    Set UserControl.Font = oTempFont
    
    Exit Function
    
GetListItemHeight_err:
    GetListItemHeight = TextHeight("O") ' pass back the current fonts textheight
End Function

Private Sub CalcOffset()
'   *********************************************************************************
'   * Purpose:  Calculates how far left and from the top to start the drawing
'   *               of the objects. This is calculated by the value of the Appearance
'   *               and BorderStyle properties.
'   *********************************************************************************
    Dim iOffset As Integer
    
    If m_eBorderStyle = gtFixedSingle And m_eAppearance = gt3D Then
        iOffset = 2
    ElseIf m_eBorderStyle = gtFixedSingle Then
        iOffset = 1
    Else
       iOffset = 0
    End If
    
    m_iOffset = iOffset
    m_oColumnHeaders.Offset = iOffset
    m_oListItems.Offset = iOffset
    
End Sub
Private Sub CalculateScaleUnits()
'   *********************************************************************************
'   * Purpose:  Calculates the number of scale units per pixel because all
'   *               drawing is based on pixels. This allows the values to be returned
'   *               in the Scale that user is expecting. This is based on the ScaleMode
'   *               of the container.
'   *********************************************************************************
    Dim iScalePerPixel As Integer
    
    Select Case Ambient.ScaleUnits
        Case "Twip":
            iScalePerPixel = ScaleX(1, vbPixels, vbTwips)
        Case "Pixel":
            iScalePerPixel = 1
        Case "Inch":
            iScalePerPixel = ScaleX(1, vbPixels, vbInches)
        Case "User":
            iScalePerPixel = 1
'            iScalePerPixel = ScaleX(1, vbPixels, vbUser)
        Case "Point":
            iScalePerPixel = ScaleX(1, vbPixels, vbPoints)
        Case "Millimeter":
            iScalePerPixel = ScaleX(1, vbPixels, vbMillimeters)
        Case "Centimeter":
            iScalePerPixel = ScaleX(1, vbPixels, vbCentimeters)
    End Select
    
    m_oColumnHeaders.ScalePerPixel = iScalePerPixel
    m_iScalePerPixel = iScalePerPixel
    
End Sub

Public Function HitTest(x As Single, y As Single) As GTListItem
Attribute HitTest.VB_Description = "Returns a reference to the ListItem object or Node object located at the coordinates of x and y. Used with drag and drop operations."
Attribute HitTest.VB_HelpID = 3
'   *********************************************************************************
'   * Purpose:  Calls the HitTest method off m_oListItems. Calculates the
'   *               the x and y based on the scale units.
'   *********************************************************************************
    Set HitTest = m_oListItems.HitTest(x / m_iScalePerPixel, y / m_iScalePerPixel)
End Function


Public Sub ShowAboutBox()
Attribute ShowAboutBox.VB_HelpID = 8
Attribute ShowAboutBox.VB_UserMemId = -552
Attribute ShowAboutBox.VB_MemberFlags = "40"
    
End Sub

Private Sub ReadObjectProps(oPropBag As PropertyBag)
'   ***********************************************************************
'   * Params:   oPropBag: the property bag to read property values from
'   * Purpose:  Reads the properties from the property bag. Reads only
'   *               the properties for objects that were changed at design time
'   *               thru the property pages.
'   ***********************************************************************
    Dim i As Long
    Dim lCount As Long
    Dim lHeight As Long
    Dim lWidth As Long
    Dim oHeader As GTColumnHeader
    
    lCount = oPropBag.ReadProperty("NumColumns", 0)
    
    For i = 1 To lCount
        
        Set oHeader = m_oColumnHeaders.Add()
        oHeader.Alignment = oPropBag.ReadProperty("ColAlignment" & i, vbLeftJustify)
        oHeader.InternalWidth = oPropBag.ReadProperty("ColInternalWidth" & i, 150)
        oHeader.Text = oPropBag.ReadProperty("ColText" & i, "")
        oHeader.Key = oPropBag.ReadProperty("ColKey" & i, "")
        oHeader.Visible = oPropBag.ReadProperty("ColVisible" & i, True)
    
    Next
    
    SetHScrollbarMax
End Sub
Private Sub WriteObjectProps(oPropBag As PropertyBag)
'   ***********************************************************************
'   * Params:   oPropBag: the property bag to write property values to
'   * Purpose:  Writes the properties to the property bag. Writes only
'   *               the properties for objects that were changed at design time
'   *               thru the property pages.
'   ***********************************************************************
    Dim oHeader As GTColumnHeader
    
    Call oPropBag.WriteProperty("NumColumns", m_oColumnHeaders.Count, 0)
    
    For Each oHeader In m_oColumnHeaders
        
        Call oPropBag.WriteProperty("ColAlignment" & oHeader.Index, oHeader.Alignment, vbLeftJustify)
        Call oPropBag.WriteProperty("ColInternalWidth" & oHeader.Index, oHeader.InternalWidth, 150)
        Call oPropBag.WriteProperty("ColText" & oHeader.Index, oHeader.Text, "")
        Call oPropBag.WriteProperty("ColKey" & oHeader.Index, oHeader.Key, "")
        Call oPropBag.WriteProperty("ColVisible" & oHeader.Index, oHeader.Visible, True)
        
    Next
    
End Sub

Private Sub SetSplitterProps()
'   ***********************************************************************
'   * Purpose:  Sets the properties for the splitter rect for resizing
'   *                the columns.
'   ***********************************************************************
    m_CSplitter.ParentHeight = ScaleHeight - m_iOffset * 2
    m_CSplitter.ParentWidth = ScaleWidth - m_iOffset * 2
    m_CSplitter.Height = ScaleHeight - m_iOffset * 2
End Sub

Private Sub DrawListItemBackground(hdc As Long)
'   ***********************************************************************
'   * Params:   hDC: the dc to draw on
'   * Purpose:  Draws the background for the listitems.
'   ***********************************************************************
    Dim lOldBackColor As Long
    Dim lTop As Long
    
    If m_oColumnHeaders.Count = 0 Then
        lTop = m_iOffset
    Else
        lTop = m_lColumnHeaderHeight + m_iOffset
    End If
    
    m_CPaint.DrawBackground hdc, CLng(m_iOffset), lTop, (ScaleWidth - m_iOffset), (ScaleHeight - m_iOffset - lTop), _
                    UserControl.BackColor

End Sub

Private Function GetFirstVisibleHeader() As GTColumnHeader
'   ***********************************************************************
'   * Return:   GTColumnHeader: the first visible columnheader if
'   *               one is found, otherwise nothing
'   * Purpose:  Loops thru the columnheader collection looking for
'   *               the first visible columnheader based on the Visible
'   *               property. This is used when drawing the highlighting
'   *               of the columns when SelectionType is gtListView.
'   ***********************************************************************
    Dim oHeader As GTColumnHeader
    
    For Each oHeader In m_oColumnHeaders
        If oHeader.Visible Then
            Set GetFirstVisibleHeader = oHeader
            Exit Function
        End If
    Next
    
End Function

Private Function IsParentActiveWindow() As Boolean
'   ***********************************************************************
'   * Return:   Boolean: If the parent is the active window or not
'   * Purpose:  Returns whether the parent is active or not
'   * Added:    Ver 1.0a
'   ***********************************************************************
    Dim hwndActiveWindow As Long
    
    On Error Resume Next
    
    hwndActiveWindow = GetActiveWindow()
    
    IsParentActiveWindow = (hwndActiveWindow = Parent.hWnd)
End Function

Private Sub SetActiveFlag()
'   ***********************************************************************
'   * Purpose:  Sets the Active window flag
'   * Added:    Ver 1.0a
'   ***********************************************************************
    m_bParentIsActive = IsParentActiveWindow()
End Sub

