Attribute VB_Name = "MGlobals"
'   ******************************************************************************
'   * Purpose:  Global variables
'   * File:         MGlobals.bas
'   ******************************************************************************
Option Explicit

'   ***** Ver 1.0a Need for subclassing
Public Const CTL_PREFIX = "SPLITTER"
'   ****
'   ***** system color constants
Public Const COLOR_BTNFACE = 15
Public Const COLOR_BTNHIGHLIGHT = 20
Public Const COLOR_BTNSHADOW = 16
Public Const COLOR_BTNTEXT = 18
'   *****

'   ***** DrawText constants
Public Const DT_SINGLELINE = &H20
Public Const DT_BOTTOM = &H8
Public Const DT_CENTER = &H1
Public Const DT_LEFT = &H0
Public Const DT_RIGHT = &H2
Public Const DT_TOP = &H0
Public Const DT_VCENTER = &H4
Public Const DT_WORDBREAK = &H10
Public Const DT_NOCLIP = &H100
Public Const DT_END_ELIPSE = &H8000
Public Const DT_WORD_ELIPSE = &H40000
'   *****

'   ***** API Declarations
Declare Function SetCapture Lib "user32" (ByVal hWnd As Long) As Long
Declare Function ReleaseCapture Lib "user32" () As Long
Declare Function GetBkColor Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function GetTextColor Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Declare Function MoveWindow Lib "user32" (ByVal hWnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hWnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long
Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Declare Function GetActiveWindow Lib "user32" () As Long
Declare Function SetForegroundWindow Lib "user32" (ByVal hWnd As Long) As Long
'   *****

Public g_bInternalUse As Boolean

Public Const IDC_SPLITTERH = 120
Public Const IDC_SPLITTERV = 121

