VERSION 5.00
Begin VB.Form frmToolTip 
   BackColor       =   &H80000018&
   BorderStyle     =   0  'None
   ClientHeight    =   750
   ClientLeft      =   6900
   ClientTop       =   3300
   ClientWidth     =   2175
   ForeColor       =   &H80000017&
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   50
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   145
   ShowInTaskbar   =   0   'False
End
Attribute VB_Name = "frmToolTip"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'   ******************************************************************************
'   * Purpose:  This form appears as a tooltip when visible
'   * File:         ToolTips.frm
'   ******************************************************************************
Option Explicit
Private m_sTip As String
Private m_CDrawRect As CDrawRect

Public Property Let ToolTip(sTip As String)
    m_sTip = sTip ' stores the tooltip text
    ' size the form base on the width and height of the text
    Me.Width = ScaleX(TextWidth(m_sTip + Space(3)), vbPixels, vbTwips)
    Me.Height = ScaleY(TextHeight("O") + 4, vbPixels, vbTwips)
    PaintTip ' paints the text on the form
End Property

Private Sub Form_Load()
    Set m_CDrawRect = New CDrawRect ' initializes the class
End Sub

Private Sub Form_Paint()
    PaintTip ' calls for the tooltip to be drawn on the form
End Sub

Private Sub Form_Resize()
    ' resizes the form based on the textwidth and height
'    Me.Width = ScaleX(TextWidth(m_sTip + Space(5)), vbPixels, vbTwips)
'    Me.Height = ScaleY(TextHeight("O") + 4, vbPixels, vbTwips)
End Sub
Private Sub PaintTip()
'   ******************************************************************************
'   * Purpose: Draws the text onto the dc of the form.
'   ******************************************************************************
    Dim rectTip As RECT
    
    Cls ' clears the forms
    
    ' draws a 3D rect around the form
    m_CDrawRect.Draw3DRect hdc, 0, 0, ScaleWidth, ScaleHeight, ToolbarActive
    
    ' ***** sets the properties of the rectangle
    rectTip.Left = 0
    rectTip.Top = 0
    rectTip.Bottom = rectTip.Top + TextHeight("O") + 4
    rectTip.Right = rectTip.Left + ScaleWidth
    ' *****
    ' draw the text on the dc
    DrawText hdc, m_sTip, rectTip, DT_SINGLELINE Or DT_WORD_ELIPSE Or DT_VCENTER, gtCenter
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Set m_CDrawRect = Nothing ' releases the object
End Sub
